

''========================================================================

'' 
'' Derived From FreeBasic 0.18.3 distr GL example SplitView
'' Rewritten using only Windows SDK and OpenGL
'' to work smoothly on Vista
'' Supports AntiAliasing if available
'' (PowerBasic 8.04 translatiob also available)
''
'' Charles E V Pegge 07:40 04 March 2008

 ' 09:29 11/07/2008

 ' to compile:
 ' fbc -s gui OpenglSplitViewA.bas



'' original notes:
''========================================================================
'' T*=
'' The program uses a "split window" view, rendering four views of the
'' same scene in one window (e.g. uesful for 3D modelling software). This
'' demo uses scissors to separete the four different rendering areas from
'' each other.
''
'' (If the code seems a little bit strange here and there, it may be
''  because I am not a friend of orthogonal projections)
''========================================================================


    #INCLUDE "WINDOWS.BI"
    #INCLUDE "GL\GL.BI"
    #INCLUDE "GL\GLEXT.BI"
    #INCLUDE "GL\GLU.BI"

    #define NULL 0
    #define FALSE 0
'    #define TRUE -1
    #define PI 3.14159265358979323846




' ARB Extensions

'Sep 2006
#define WGL_NUMBER_PIXEL_FORMATS_ARB      &h2000
#define WGL_DRAW_TO_WINDOW_ARB            &h2001
#define WGL_DRAW_TO_BITMAP_ARB            &h2002
#define WGL_ACCELERATION_ARB              &h2003
#define WGL_NEED_PALETTE_ARB              &h2004
#define WGL_NEED_SYSTEM_PALETTE_ARB       &h2005
#define WGL_SWAP_LAYER_BUFFERS_ARB        &h2006
#define WGL_SWAP_METHOD_ARB               &h2007
#define WGL_NUMBER_OVERLAYS_ARB           &h2008
#define WGL_NUMBER_UNDERLAYS_ARB          &h2009
#define WGL_TRANSPARENT_ARB               &h200A
#define WGL_TRANSPARENT_RED_VALUE_ARB     &h2037
#define WGL_TRANSPARENT_GREEN_VALUE_ARB   &h2038
#define WGL_TRANSPARENT_BLUE_VALUE_ARB    &h2039
#define WGL_TRANSPARENT_ALPHA_VALUE_ARB   &h203A
#define WGL_TRANSPARENT_INDEX_VALUE_ARB   &h203B
#define WGL_SHARE_DEPTH_ARB               &h200C
#define WGL_SHARE_STENCIL_ARB             &h200D
#define WGL_SHARE_ACCUM_ARB               &h200E
#define WGL_SUPPORT_GDI_ARB               &h200F
#define WGL_SUPPORT_OPENGL_ARB            &h2010
#define WGL_DOUBLE_BUFFER_ARB             &h2011
#define WGL_STEREO_ARB                    &h2012
#define WGL_PIXEL_TYPE_ARB                &h2013
#define WGL_COLOR_BITS_ARB                &h2014
#define WGL_RED_BITS_ARB                  &h2015
#define WGL_RED_SHIFT_ARB                 &h2016
#define WGL_GREEN_BITS_ARB                &h2017
#define WGL_GREEN_SHIFT_ARB               &h2018
#define WGL_BLUE_BITS_ARB                 &h2019
#define WGL_BLUE_SHIFT_ARB                &h201A
#define WGL_ALPHA_BITS_ARB                &h201B
#define WGL_ALPHA_SHIFT_ARB               &h201C
#define WGL_ACCUM_BITS_ARB                &h201D
#define WGL_ACCUM_RED_BITS_ARB            &h201E
#define WGL_ACCUM_GREEN_BITS_ARB          &h201F
#define WGL_ACCUM_BLUE_BITS_ARB           &h2020
#define WGL_ACCUM_ALPHA_BITS_ARB          &h2021
#define WGL_DEPTH_BITS_ARB                &h2022
#define WGL_STENCIL_BITS_ARB              &h2023
#define WGL_AUX_BUFFERS_ARB               &h2024
#define WGL_NO_ACCELERATION_ARB           &h2025
#define WGL_GENERIC_ACCELERATION_ARB      &h2026
#define WGL_FULL_ACCELERATION_ARB         &h2027
#define WGL_SWAP_EXCHANGE_ARB             &h2028
#define WGL_SWAP_COPY_ARB                 &h2029
#define WGL_SWAP_UNDEFINED_ARB            &h202A
#define WGL_TYPE_RGBA_ARB                 &h202B
#define WGL_TYPE_COLORINDEX_ARB           &h202C
#define WGL_SAMPLE_BUFFERS_ARB            &h2041
#define WGL_SAMPLES_ARB                   &h2042

#define GL_MULTISAMPLE_ARB                &h809D
#define GL_SAMPLE_ALPHA_TO_COVERAGE_ARB   &h809E
#define GL_SAMPLE_ALPHA_TO_ONE_ARB        &h809F
#define GL_SAMPLE_COVERAGE_ARB            &h80A0
#define GL_SAMPLE_BUFFERS_ARB             &h80A8
#define GL_SAMPLES_ARB                    &h80A9
#define GL_SAMPLE_COVERAGE_VALUE_ARB      &h80AA
#define GL_SAMPLE_COVERAGE_INVERT_ARB     &h80AB


' ARB extension needed for for shadow mapping

#define GL_DEPTH_TEXTURE_MODE_ARB         &h884B

#define GL_TEXTURE_COMPARE_MODE_ARB       &h884C
#define GL_TEXTURE_COMPARE_FUNC_ARB       &h884D
#define GL_COMPARE_R_TO_TEXTURE_ARB       &h884E

' Opengl 1.4
#define GL_COMPARE_R_TO_TEXTURE           &h884E


'#define WGL_SUPPORT_OPENGL_ARB            &h2010


''========================================================================
'' Global variables
''========================================================================

    dim shared as LARGE_INTEGER grtic1,grtic2,freq
    dim shared as double fps,grlap
    dim shared as long   refresh,bselect,kselect,keyd,char,ReqShutDown
    dim shared as long   bLeft,bMid,bRight,bWheel
    dim shared as long   sposx,sposy,mposx,mposy,eposx,eposy
    dim shared as long   wWidth,wHeight
    dim shared as HDC hDC
    dim shared as HGLRC hRC
    dim shared as long   shadows,shadowable
    dim shared as long   antialias, multisampling
    dim shared as long   nPixelFormat,ReqNewMode,arbMultisampleFormat, arbMultisampleSupported
    dim shared as long   timerval

''========================================================================
    dim shared as long doredraw
    '' Mouse position
    dim shared as long xpos, ypos
    '' Window size wWidth wHeight
    '' Active view: 0 = none, 1 = upper left, 2 = upper right, 3 = lower left,
    '' 4 = lower right
    dim shared as long active_view
    '' Rotation around each axis
    dim shared as long rot_x, rot_y, rot_z

''========================================================================



''========================================================================
'' replace a substring with another substring throughout a string
''========================================================================
sub replace(s as string, f as string, r as string)
    dim as long i,j,k,l,m
    l=len(f)
    m=len(r)
    i=1
    do
     i=instr(i,s,f)
     if i=0 then exit do
     s=left$(s,i-1)+r+mid$(s,i+l)
     i+=m
    loop
end sub



''========================================================================
'' DrawTorus() - Draw a solid torus (use a display list for the model)
''========================================================================

'#define TORUS_MAJOR     1.5
'#define TORUS_MINOR     0.5
'#define TORUS_MAJOR_RES  32
'#define TORUS_MINOR_RES  32

dim shared as double TORUS_MAJOR=1.5,TORUS_MINOR=0.5, half=0.5
dim shared as long TORUS_MAJOR_RES=32,TORUS_MINOR_RES=32

sub DrawTorus( )
    STATIC as uinteger torus_list
    dim as long i, j, k
    dim as double s, t, x, y, z, nx, ny, nz, gscale, twopi
  asm
    cmp dword ptr [torus_list],0
    jz build_torus
    push dword ptr [torus_list]
    call glCallList
  end asm

  exit sub


'    IF( torus_list = 0 ) THEN
'        '' Start recording displaylist
'        torus_list = glGenLists( 1 )
'        glNewList( torus_list, GL_COMPILE_AND_EXECUTE )
'

        '' Draw torus
  asm
    build_torus:
    push 1
    call glGenLists
    mov dword ptr [torus_list],eax
    '
    push GL_COMPILE_AND_EXECUTE
    push dword ptr [torus_list]
    call glNewList
    '
    fldpi
    fadd st(0),st(0)
    fstp qword ptr [twopi]
    '
    mov dword ptr [i],0
    toro_do1:
        'twopi = 2.0 * PI
        'FOR i = 0 TO TORUS_MINOR_RES-1
        '    glBegin( GL_QUAD_STRIP )
    push GL_QUAD_STRIP
    call glBegin
    mov dword ptr [j],0
    toro_do2:
    mov dword ptr [k],1
    toro_do3:
            'FOR j = 0 TO TORUS_MAJOR_RES
                'FOR k = 1 TO 0 STEP -1
                    's = (i + k) MOD TORUS_MINOR_RES + 0.5
                    't = j MOD TORUS_MAJOR_RES
                    '
                    '' Calculate point on surface
                    'x = (TORUS_MAJOR+TORUS_MINOR*COS(s*twopi/TORUS_MINOR_RES))*COS(t*twopi/TORUS_MAJOR_RES)
                    'y = TORUS_MINOR * SIN(s * twopi / TORUS_MINOR_RES)
                    'z = (TORUS_MAJOR+TORUS_MINOR*COS(s*twopi/TORUS_MINOR_RES))*SIN(t*twopi/TORUS_MAJOR_RES)
                    '
                    '' Calculate surface normal
                    'nx = x - TORUS_MAJOR*COS(t*twopi/TORUS_MAJOR_RES)
                    'ny = y
                    'nz = z - TORUS_MAJOR*SIN(t*twopi/TORUS_MAJOR_RES)
                    'gscale = 1.0 / SQR( nx*nx + ny*ny + nz*nz )
    '
    fild   dword ptr [torus_minor_res]
    fild   dword ptr [i]
    fiadd  dword ptr [k]
    fprem
    fadd   qword ptr [half]
    fstp   qword ptr [s]
    fcomp st(0)
    '
    fild  dword ptr [torus_major_res]
    fild  dword ptr [j]
    fprem
    fstp  qword ptr [t]
    fcomp st(0)
    '
    ' Calculate point on surface
    ' x
    fld   qword ptr [torus_major]
    fld   qword ptr [torus_minor]
    fld   qword ptr [s]
    fmul  qword ptr [twopi]
    fidiv dword ptr [torus_minor_res]
    fcos
    fmulp st(1),st(0)
    faddp st(1),st(0)
    '
    fld   qword ptr [t]
    fmul  qword ptr [twopi]
    fidiv dword ptr [torus_major_res]
    fcos
    fmulp st(1),st(0)
    fstp qword ptr [x]
    ' y
    fld   qword ptr [torus_minor]
    fld   qword ptr [s]
    fmul  qword ptr [twopi]
    fidiv dword ptr [torus_minor_res]
    fsin
    fmulp st(1),st(0)
    fstp qword ptr [y]
    ' z
    fld  qword ptr  [torus_major]
    fld  qword ptr  [torus_minor]
    fld  qword ptr  [s]
    fmul qword ptr  [twopi]
    fidiv dword ptr [torus_minor_res]
    fcos
    fmulp st(1),st(0)
    faddp st(1),st(0)
    '
    fld   qword ptr [t]
    fmul  qword ptr [twopi]
    fidiv dword ptr [torus_major_res]
    fsin
    fmulp st(1),st(0)
    fstp qword ptr [z]
    '
    ' Calculate surface normal
    '
    fld   qword ptr [x]
    fld   qword ptr [t]
    fmul  qword ptr [twopi]
    fidiv dword ptr [torus_major_res]
    fcos
    fmul  qword ptr [torus_major]
    fsubp st(1),st(0)
    fstp  qword ptr [nx]
    '
    fld  qword ptr [y]
    fstp qword ptr [ny]
    '
    fld   qword ptr [z]
    fld   qword ptr [t]
    fmul  qword ptr [twopi]
    fidiv dword ptr [torus_major_res]
    fsin
    fmul  qword ptr [torus_major]
    fsubp st(1),st(0)
    fstp  qword ptr [nz]
    '
    fld1
    fld qword ptr [nx]
    fmul st(0),st(0)
    fld qword ptr [ny]
    fmul st(0),st(0)
    fld qword ptr [nz]
    fmul st(0),st(0)
    faddp st(1),st(0)
    faddp st(1),st(0)
    fsqrt
    fdivp st(1),st(0)
    fstp qword ptr [gscale]
    '
    fld  qword ptr [nx]
    fmul qword ptr [gscale]
    fstp qword ptr [nx]
    fld  qword ptr [ny]
    fmul qword ptr [gscale]
    fstp qword ptr [ny]
    fld  qword ptr [nz]
    fmul qword ptr [gscale]
    fstp qword ptr [nz]
    '
    push edi
    sub esp,16
    mov edi,esp
    '
    ' normals
    '
    fld  qword ptr [nx]
    fstp dword ptr [edi+0]
    fld  qword ptr [ny]
    fstp dword ptr [edi+4]
    fld  qword ptr [nz]
    fstp dword ptr [edi+8]
    push edi
    call glNormal3fv
    fld  qword ptr [x]
    fstp dword ptr [edi+0]
    fld  qword ptr [y]
    fstp dword ptr [edi+4]
    fld  qword ptr [z]
    fstp dword ptr [edi+8]
    push edi
    call glVertex3fv
    '
    add esp,16
    pop edi
                    'nx = nx*gscale
                    'ny = ny*gscale
                    'nz = nz*gscale

                    'glNormal3f( nx, ny, nz )
                    'glVertex3f( x, y, z )


    dec dword ptr [k]
    cmp dword ptr [k],0
    jge toro_do3
    inc dword ptr [j]
    mov eax,torus_major_res
    cmp dword ptr [j],eax
    jle toro_do2
    call glend
    inc dword ptr [i]
    mov eax,torus_minor_res
    cmp dword ptr [i],eax 
    jl toro_do1
    call glEndlist
'                NEXT k
'            NEXT j
'            glEnd()
'        NEXT i
'
        '' Stop recording displaylist
        'glEndList()
  end asm
'    ELSE
'        '' Playback displaylist
'        glCallList torus_list 
'    end if
end sub




''========================================================================
'' DrawScene() - Draw the scene (a rotating torus)
''========================================================================


sub DrawScene(  )
    static as single model_diffuse(0 TO 3)  => { 1.0, 0.8, 0.8, 1.0 }
    static as single model_specular(0 TO 3) => { 0.6, 0.6, 0.6, 1.0 }
    static as single model_shininess = 20.0

    glPushMatrix( )

    '' Rotate the object
    glRotatef( rot_x*0.5, 1.0, 0.0, 0.0 )
    glRotatef( rot_y*0.5, 0.0, 1.0, 0.0 )
    glRotatef( rot_z*0.5, 0.0, 0.0, 1.0 )

    '' Set model color (used for orthogonal views, lighting disabled)
    glColor4fv( @model_diffuse(0) )

    '' Set model material (used for perspective view, lighting enabled)
    glMaterialfv( GL_FRONT, GL_DIFFUSE, @model_diffuse(0) )
    glMaterialfv( GL_FRONT, GL_SPECULAR, @model_specular(0) )
    glMaterialf(  GL_FRONT, GL_SHININESS, model_shininess )

    '' Draw torus
    DrawTorus()

    glPopMatrix()
end sub


''========================================================================
'' DrawGrid() - Draw a 2D grid (used for orthogonal views)
''========================================================================


sub DrawGrid( BYVAL gscale AS SINGLE, BYVAL gsteps AS INTEGER )
    dim as long i
    dim as single x, y


asm
  call glPushMatrix 
  '' Set background to some dark bluish grey
  sub esp,16
  mov edx,esp
  mov dword ptr [edx],20
  fld1
  fidiv dword ptr [edx]
  fst dword ptr [edx]
  fst dword ptr [edx+4]
  fadd st(0),st(0)
  fadd st(0),st(0)
  fstp dword ptr [edx+8]
  fldz
  fstp dword ptr [edx+12]
  call glClearColor ' ( 0.05, 0.05, 0.2, 0.0)
  push &h4000 ' GL_COLOR_BUFFER_BIT
  call glClear
    '' Setup modelview matrix (flat XY view)
  call  glLoadIdentity ' ( )
  sub esp,72
  mov edx,esp
  fldz
  fst  qword ptr [edx+00]
  fst  qword ptr [edx+08]
  fst  qword ptr [edx+24]
  fst  qword ptr [edx+32]
  fst  qword ptr [edx+40]
  fst  qword ptr [edx+48]
  fstp qword ptr [edx+64]
  fld1
  fst  qword ptr [edx+16]
  fstp qword ptr [edx+56]
  call gluLookAt   ' ( 0.0, 0.0, 1.0, _
                   ' 0.0, 0.0, 0.0, _
                   ' 0.0, 1.0, 0.0 )

    '' We don't want to update the Z-buffer
    push 0 ' GL_FALSE
    call glDepthMask
    '' Set grid color
    push &hb50 ' GL_LIGHTING
    call gldisable
    sub esp,12
    mov edx,esp
    fldz
    fstp dword ptr [edx+00]
    fld1
    fld1
    fadd  st(0),st(0)
    fdivp st(1),st(0)
    fst  dword ptr [edx+4]
    fstp dword ptr [edx+8]
    call glColor3f ' ( 0.0, 0.5, 0.5 )
    push 1 ' GL_LINES
    call glbegin

    ' horizontals
    '
    fld1
    sub esp,4
    mov edx,esp
    mov   dword ptr [edx],2
    fidiv dword ptr [edx]
    fmul  dword ptr [gscale]
    fild  dword ptr [gsteps]
    fld1
    fsubp st(1),st(0)
    add esp,4
    fmulp st(1),st(0)
    fst dword ptr [x]
    fchs
    fstp dword ptr [y]

     mov esi,0
   rgridy:
      sub esp,12
      mov edx,esp
      fld  dword ptr [x]
      fchs
      fstp dword ptr [edx]
      fld  dword ptr [y]
      fstp dword ptr [edx+4]
      fldz
      fstp dword ptr [edx+8]
    call glvertex3f
      '
      sub esp,12
      mov edx,esp
      fld  dword ptr [x]
      fstp dword ptr [edx]
      fld  dword ptr [y]
      fst dword ptr  [edx+4]
      fadd dword ptr [gscale]
      fstp dword ptr [y]
      fldz
      fstp dword ptr [edx+8]
    call glvertex3f
    inc esi
    cmp esi,[gsteps]
    jl rgridy


    'verticals


    fld1
    sub esp,4
    mov edx,esp
    mov   dword ptr [edx],2
    fidiv dword ptr [edx]
    fmul  dword ptr [gscale]
    fild  dword ptr [gsteps]
    fld1
    fsubp st(1),st(0)
    add esp,4
    fmulp st(1),st(0)
    fst dword ptr [y]
    fchs
    fstp dword ptr [x]

     mov esi,0
   rgridx:
      sub esp,12
      mov edx,esp
      fld  dword ptr [x]
      fstp dword ptr [edx]
      fld  dword ptr [y]
      fchs
      fstp dword ptr [edx+4]
      fldz
      fstp dword ptr [edx+8]
    call glvertex3f
      '
      sub esp,12
      mov edx,esp
      fld  dword ptr [x]
      fst  dword ptr [edx]
      fadd dword ptr [gscale]
      fstp dword ptr [x]
      fld  dword ptr [y]
      fstp dword ptr  [edx+4]
      fldz
      fstp dword ptr [edx+8]
    call glvertex3f
    inc esi
    cmp esi,[gsteps]
    jl rgridx

    call glend
    push 1 ' GL_TRUE
    call glDepthMask
    call glPopMatrix
end asm
    
    '' Horizontal lines
    'x = gscale * 0.5 * (gsteps-1)
    'y = -gscale * 0.5 * (gsteps-1)
    'FOR i = 0 TO gsteps-1
    '    glVertex3f( -x, y, 0.0 )
    '    glVertex3f( x, y, 0.0 )
    '    y = y + gscale
    'NEXT

    '' Vertical lines
    'x = -gscale * 0.5 * (gsteps-1)
    'y = gscale * 0.5 * (gsteps-1)
    'FOR i = 0 TO gsteps-1
    '    glVertex3f( x, -y, 0.0 )
    '    glVertex3f( x, y, 0.0 )
    '    x = x + gscale
    'NEXT

    'glEnd()

    '' Enable Z-buffer writing again
    'glDepthMask( GL_TRUE )

    'glPopMatrix()
end sub


''========================================================================
'' DrawAllViews()
''========================================================================




'

sub DrawAllViews( )
    static as single light_position(0 TO 3) =>  { 0.0, 8.0, 8.0, 1.0 }
    static as single light_diffuse(0 TO 3)  =>  { 1.0, 1.0, 1.0, 1.0 }
    static as single light_specular(0 TO 3) =>  { 1.0, 1.0, 1.0, 1.0 }
    static as single light_ambient(0 TO 3)  =>  { 0.2, 0.2, 0.3, 1.0 }
    static as double aspect

asm
    '' Calculate aspect of window
  fld1
  fstp qword ptr [aspect]
  cmp dword ptr [wheight],0
  jle aspok
  fild  dword ptr [wwidth]
  fidiv dword ptr [wheight]
  fstp qword ptr [aspect]
  aspok:
  '  IF( wheight > 0 ) THEN
  '      aspect = wwidth / wheight
  '  ELSE
  '      aspect = 1.0
  '  end if
    '' Clear screen
    push 0
    push 0
    push 0
    push 0
    call glClearColor ' ( 0.0, 0.0, 0.0, 0.0 )
    push &h4100
    call glClear '( GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT )
    push &hc11
    call glEnable ' ( GL_SCISSOR_TEST )
    '' Enable depth test
    push &hb71
    call glEnable' ( GL_DEPTH_TEST )
    push &h203
    call glDepthFunc ' ( GL_LEQUAL )

    '' ** ORTHOGONAL VIEWS **

    '' For orthogonal views, use wireframe rendering
    push &h1b01
    push &h408
    call glPolygonMode ' ( GL_FRONT_AND_BACK, GL_LINE ) ' 0408  1b01

    '' Enable line anti-aliasing
    push &h0b20
    call glEnable' ( GL_LINE_SMOOTH )
    push &hbe2
    call glEnable'( GL_BLEND )
    push &h303
    push &h302
    call glBlendFunc ' ( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )
    '' Setup orthogonal projection matrix
    push &h1701
    call glMatrixMode ' ( GL_PROJECTION )
    call glLoadIdentity '( )
    sub esp,48
    mov edx,esp
    mov  dword ptr [edx],3
    fild dword ptr [edx]
    fst  qword ptr [edx+24]
    fchs
    fst  qword ptr [edx+16]
    fmul qword ptr [aspect]
    fst  qword ptr [edx]
    fchs
    fstp qword ptr [edx+8]
    fld1
    fstp qword ptr [edx+32]
    mov dword ptr  [edx+40],50
    fild dword ptr [edx+40]
    fstp qword ptr [edx+40]

    call glOrtho ' ( -3.0*aspect, 3.0*aspect, -3.0, 3.0, 1.0, 50.0 )


    '' Upper left view (TOP VIEW)
    sub esp,16
    mov edx,esp
    mov dword ptr [edx],0
    mov eax,[wheight]
    shr eax,1
    mov [edx+4],eax
    mov [edx+12],eax
    mov eax,[wwidth]
    shr eax,1
    mov [edx+8],eax
  call glViewport ' ( 0, wheight\2, wwidth\2, wheight\2 )
    sub esp,16
    mov edx,esp
    mov dword ptr [edx],0
    mov eax,[wheight]
    shr eax,1
    mov [edx+4],eax
    mov [edx+12],eax
    mov eax,[wwidth]
    shr eax,1
    mov [edx+8],eax
  call glScissor ' ( 0, wheight\2, wwidth\2, wheight\2 )
  push &h1700
  call glMatrixMode
  call glLoadIdentity
  sub esp,72
  mov edx,esp
  fldz
  fst  qword ptr [edx]
  fst  qword ptr [edx+24]
  fst  qword ptr [edx+32]
  fst  qword ptr [edx+40]
  fst  qword ptr [edx+48]
  fstp qword ptr [edx+64]
  mov  dword ptr [edx+8],10
  fild dword ptr [edx+8]
  fstp qword ptr [edx+8]
  fld1
  mov   dword ptr [edx+16],1000
  fidiv dword ptr [edx+16]
  fstp  qword ptr [edx+16]
  fld1
  fstp  qword ptr [edx+56]
  call  gluLookAt '( 0.0, 10.0, 1e-3, _  '' Eye-position (above)
                  '  0.0, 0.0, 0.0,   _  '' View-point
                  '  0.0, 1.0, 0.0 )     '' Up-vector
  sub esp,8
  mov edx,esp
  mov   dword ptr [edx],2
  fld1
  fidiv dword ptr [edx]
  fstp  dword ptr [edx]
  mov   dword ptr [edx+4],12
  call DrawGrid   '( 0.5, 12 )
  call DrawScene  '( )

    '' Lower left view (FRONT VIEW)

    sub esp,16
    mov edx,esp
    mov dword ptr [edx],0
    mov dword ptr [edx+4],0
    mov eax,[wheight]
    shr eax,1
    mov [edx+12],eax
    mov eax,[wwidth]
    shr eax,1
    mov [edx+8],eax
    call glViewport ' ( 0, 0, wwidth\2, wheight\2 )
    sub esp,16
    mov edx,esp
    mov dword ptr [edx],0
    mov dword ptr [edx+4],0
    mov eax,[wheight]
    shr eax,1
    mov [edx+12],eax
    mov eax,[wwidth]
    shr eax,1
    mov [edx+8],eax
  call glScissor ' ( 0, 0, wwidth\2, wheight\2 )
  push &h1700
  call glMatrixMode
  call glLoadIdentity
  sub esp,72
  mov edx,esp
  fldz
  fst  qword ptr [edx]
  fst  qword ptr [edx+8]
  fst  qword ptr [edx+24]
  fst  qword ptr [edx+32]
  fst  qword ptr [edx+40]
  fst  qword ptr [edx+48]
  fstp qword ptr [edx+64]
  mov  dword ptr [edx+16],10
  fild dword ptr [edx+16]
  fstp qword ptr [edx+16]
  fld1
  fstp  qword ptr [edx+56]
  call  gluLookAt '( 0.0, 0.0, 10, _  '' Eye-position (above)
                  '  0.0, 0.0, 0.0,   _  '' View-point
                  '  0.0, 1.0, 0.0 )     '' Up-vector
  sub esp,8
  mov edx,esp
  mov   dword ptr [edx],2
  fld1
  fidiv dword ptr [edx]
  fstp  dword ptr [edx]
  mov   dword ptr [edx+4],12
  call DrawGrid   '( 0.5, 12 )
  call DrawScene  '( )

  '' Lower right view (SIDE VIEW)

    sub esp,16
    mov edx,esp
    mov dword ptr [edx+4],0
    mov eax,[wheight]
    shr eax,1
    mov [edx+12],eax
    mov eax,[wwidth]
    shr eax,1
    mov [edx],  eax
    mov [edx+8],eax
    call glViewport ' ( wwidth\2, 0, wwidth\2, wheight\2 )
    sub esp,16
    mov edx,esp
    mov dword ptr [edx+4],0
    mov eax,[wheight]
    shr eax,1
    mov [edx+12],eax
    mov eax,[wwidth]
    shr eax,1
    mov [edx],  eax
    mov [edx+8],eax
  call glScissor ' ( wwidth\2, 0, wwidth\2, wheight\2 )
  push &h1700
  call glMatrixMode
  call glLoadIdentity
  sub esp,72
  mov edx,esp
  fldz
  fst  qword ptr [edx+8]
  fst  qword ptr [edx+24]
  fst  qword ptr [edx+32]
  fst  qword ptr [edx+40]
  fst  qword ptr [edx+48]
  fstp qword ptr [edx+64]
  mov  dword ptr [edx],10
  fild dword ptr [edx]
  fstp qword ptr [edx]
  fld1
  fstp  qword ptr [edx+56]
  call  gluLookAt '( 10.0, 0.0, 0.0, _  '' Eye-position (above)
                  '  0.0,  0.0, 0.0,   _  '' View-point
                  '  0.0,  1.0, 0.0 )     '' Up-vector
  sub esp,8
  mov edx,esp
  mov   dword ptr [edx],2
  fld1
  fidiv dword ptr [edx]
  fstp  dword ptr [edx]
  mov   dword ptr [edx+4],12
  call DrawGrid   '( 0.5, 12 )
  call DrawScene  '( )

    '' Disable line anti-aliasing
    push &hb20
    call glDisable ' ( GL_LINE_SMOOTH )
    push &hbe2
    call glDisable ' ( GL_BLEND )


    '' ** PERSPECTIVE VIEW **

    '' For perspective view, use solid rendering
    push &h1b02
    push &h408
    call glPolygonMode' ( GL_FRONT_AND_BACK, GL_FILL )
    push &hb44
    '' Enable face culling (faster rendering)
    call glEnable ' ( GL_CULL_FACE )
    push &h405
    call glCullFace ' ( GL_BACK )
    push &h900
    call glFrontFace ' ( GL_CW )


    '' Setup perspective projection matrix
    push &h1701
    call glMatrixMode ' ( GL_PROJECTION )
    call glLoadIdentity ' ( )
    sub esp,32
    mov edx,esp
    mov  dword ptr [edx], 65
    fild dword ptr [edx]
    fstp qword ptr [edx]
    fld  qword ptr [aspect]
    fstp qword ptr [edx+8]
    fld1
    fstp qword ptr [edx+16]
    mov  dword ptr [edx+24], 50
    fild dword ptr [edx+24]
    fstp qword ptr [edx+24] 
    call gluPerspective ' ( 65.0, aspect, 1.0, 50.0 )

    '' Upper right view (PERSPECTIVE VIEW)
    sub esp,16
    mov edx,esp
    mov eax,[wwidth]
    shr eax,1
    mov [edx],eax
    mov [edx+8],eax
    mov eax,[wheight]
    shr eax,1
    mov [edx+4],eax
    mov [edx+12],eax
    call glViewport ' ( wwidth\2, wheight\2, wwidth\2, wheight\2 )
    sub esp,16
    mov edx,esp
    mov eax,[wwidth]
    shr eax,1
    mov [edx],eax
    mov [edx+8],eax
    mov eax,[wheight]
    shr eax,1
    mov [edx+4],eax
    mov [edx+12],eax
    call glScissor ' ( wwidth\2, wheight\2, wwidth\2, wheight\2 )
    push &h1700
    call glMatrixMode ' ( GL_MODELVIEW )
    call glLoadIdentity ' ()

    sub esp,72
    mov edx,esp
    fldz
    fst  qword ptr [edx+24]
    fst  qword ptr [edx+32]
    fst  qword ptr [edx+40]
    fst  qword ptr [edx+48]
    fstp qword ptr [edx+64]
    fld1
    fstp  qword ptr [edx+56]
    mov  dword ptr [edx],3
    fild dword ptr [edx]
    fst  qword ptr [edx]
    fst  qword ptr [edx+16]
    fld1
    fadd st(0),st(0)
    fdivp st(1),st(0)
    fstp  qword ptr [edx+8]
    call gluLookAt '( 3.0, 1.5, 3.0, _    '' Eye-position
                   ' 0.0, 0.0, 0.0, _    '' View-point
                   ' 0.0, 1.0, 0.0 )     '' Up-vector
    '' Configure and enable light source 1
    lea eax, [light_position]
    push eax
    push &h1203
    push &h4001
    call glLightfv ' ( GL_LIGHT1, GL_POSITION, @light_position(0) )
    lea eax, [light_ambient]
    push eax
    push &h1200
    push &h4001
    call glLightfv ' ( GL_LIGHT1, GL_AMBIENT, @light_ambient(0) )
    lea eax, [light_diffuse]
    push eax
    push &h1201
    push &h4001
    call glLightfv ' ( GL_LIGHT1, GL_DIFFUSE, @light_diffuse(0) )
    lea eax, [light_specular]
    push eax
    push &h1202
    push &h4001
    call glLightfv ' ( GL_LIGHT1, GL_SPECULAR, @light_specular(0) )
    push &h4001
    call glEnable ' ( GL_LIGHT1 )
    push &hb50
    call glEnable ' ( GL_LIGHTING )

   call DrawScene ' ( )

   '' Disable lighting
    push &hb50
    call glDisable ' ( GL_LIGHTING )
    '' Disable face culling
    push &hb44
    call glDisable ' ( GL_CULL_FACE )
    '' Disable depth test
    push &hb71
    call glDisable ' ( GL_DEPTH_TEST )
    '' Disable scissor test
    push &hc11
    call glDisable ' ( GL_SCISSOR_TEST )
    '' Draw a border around the active view
    mov eax,[active_view]
    cmp eax,0
    jz nobor
    cmp eax,2
    jz nobor
    ' IF( active_view > 0 AND active_view <> 2 ) THEN
    sub esp,16
    mov edx,esp
    mov dword ptr [edx],0
    mov dword ptr [edx+4],0
    mov eax,[wwidth]
    mov [edx+8],eax
    mov eax,[wheight]
    mov [edx+12],eax
    call glViewport ' ( 0, 0, wwidth, wheight )
    push &h1701
    call glMatrixMode ' ( GL_PROJECTION )
    call glLoadIdentity 
   sub esp,48
   mov edx,esp
   fldz
   fst   qword ptr [edx]    
   fst   qword ptr [edx+16]    
   fstp  qword ptr [edx+32]
   fld1
   fst  qword ptr [edx+40]
   fadd st(0),st(0)    
   fst   qword ptr [edx+8]    
   fstp  qword ptr [edx+24]    
   call glOrtho ' ( 0.0, 2.0, 0.0, 2.0, 0.0, 1.0 )
    push &h1700
    call glMatrixMode ' ( GL_MODELVIEW )
    call glLoadIdentity ' ()
    sub esp,12
    mov edx,esp
    fld1
    fst   dword ptr [edx]
    fstp  dword ptr [edx+4]
    mov   dword ptr [edx+8],6
    fild  dword ptr [edx+8]
    mov   dword ptr [edx+8],10
    fidiv dword ptr [edx+8]
    fstp  dword ptr [edx+8]
    call glColor3f ' ( 1.0, 1.0, 0.6 )
    sub esp,12
    mov edx,esp
    mov eax,[active_view]
    dec eax
    and eax,1
    mov [edx],eax
    fild dword ptr [edx]
    fstp dword ptr [edx]
    mov eax,[active_view]
    dec eax
    shr eax,1
    neg eax
    inc eax
    mov [edx+4],eax
    fild dword ptr [edx+4]
    fstp dword ptr [edx+4]
    mov  dword ptr [edx+8],0
    call glTranslatef ' ( (active_view-1) AND 1, 1-(active_view-1)\2, 0.0 )

    push 3
    call glBegin ' ( GL_LINE_STRIP )
    push 0
    push 0
    call glVertex2i ' ( 0, 0 )
    push 0
    push 1    
    call glVertex2i ' ( 1, 0 )
    push 1
    push 1
    call glVertex2i ' ( 1, 1 )
    push 1
    push 0
    call glVertex2i ' ( 0, 1 )
    push 0
    push 0
    call glVertex2i ' ( 0, 0 )
    call glEnd ' ()
 nobor:
end asm
end sub



sub do_the_next_frame(BYVAL hWnd AS HWND )  ' construct each frame


dim as long k10
dim as single p99

asm:
  '----------
  next_frame:
  '----------
  
    'def hWnd [ebp+8]
    
    ' timing
    'lea eax,[grtic2]
    'push eax
    'call QueryPerformanceCounter
    'grlap=(1e6*(grtic2-grtic1)/freq)
    ''fps=0.99*fps+10000/grlap ' moving average frames per sec
    'fild  dword ptr [fps]
    'fmul  dword ptr [p99]
    'fiadd dword ptr [k10]
    'fidiv dword ptr [grlap]
    'fistp dword ptr [fps]
    
    ' screen refresh
    'if bselect+kselect+refresh=0 THEN grtic1=grtic2: GOTO xdo_frame ' no need to update frame

    mov eax,[bselect]
    or  eax,[kselect]
    or  eax,[refresh]
    mov dword ptr [refresh],0
    cmp eax,0
    jz xdo_frame
end asm
    
    ' 0x4000 GL_COLOR_BUFFER_BIT 
    ' 0x0100 GL_DEPTH_BUFFER_BIT
    ' 0x4100
    'glClear &h4100 ' GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT
    DrawAllViews
    'glFinish   ' wait until all operations complete
    SwapBuffers HDC
    
    'IF firstframe=0 THEN SetWindowPos hWnd,HWND_TOP,100,100,500,500,0: firstframe=1
    'grtic1=grtic2
asm
  xdo_frame:
    lea edx,[grtic1]
    mov eax,[edx+8]
    mov [edx],eax
    mov eax,[edx+12]
    mov [edx+4],eax
  'ret 4

end asm
exit sub

                                              '
    'STATIC firstframe AS LONG
    'static shro AS LONG
    'static shrt AS SINGLE
    'static shre AS SINGLE

    'static as long signal = 0

    ' timing
    QueryPerformanceCounter @grtic2
    'grlap=(1e6*(grtic2-grtic1)/freq)
    fps=0.99*fps+10000/grlap ' moving average frames per sec

    ' screen refresh
    if bselect+kselect+refresh=0 THEN grtic1=grtic2: GOTO xdo_frame ' no need to update frame
    refresh=0

    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)

    '=============
    DrawAllViews()
    '=============
    glFinish   ' wait until all operations complete
    SwapBuffers HDC

    'IF firstframe=0 THEN SetWindowPos hWnd,HWND_TOP,100,100,500,500,0: firstframe=1
    grtic1=grtic2
xdo_frame:

    exit sub
                                              '
end sub                                    '



dim shared keys(255) AS LONG
dim shared mapref(15) AS LONG
dim shared cameraProjectionMatrix(15) AS SINGLE
dim shared modelview(15) AS DOUBLE
dim shared projection(15) AS DOUBLE


function WndProc ( byval hWnd as HWND, _
                   byval wMsg as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT


    dim gmf(255) AS  GLYPHMETRICSFLOAT
    dim viewport(3) AS LONG

    dim as long i,j
    dim as long x,y,z

    'if wmsg=wm_paint THEN refresh=1

    SELECT CASE wMsg

    'CASE WM_ACTIVATE
    '    if HIword(wParam) THEN exit function
    '
     CASE WM_DESTROY
        GOTO terminate
     CASE WM_TIMER
         if wParam=1 THEN
             do_the_next_frame (hWnd)
            if ReqShutDown THEN goto terminate
        end if
        exit function
    CASE WM_KEYDOWN
        wParam=wParam AND 255
        keys(wParam) = 1: keyd=wParam: kselect=wParam
        if wParam=VK_ESCAPE THEN ReqShutdown=1: exit function
        if (wParam>=VK_F1)AND(wParam<=VK_F12) THEN
            '..
        end if
        exit function
    CASE WM_KEYUP
        wParam=wParam AND 255
        keys(wParam) = 0:keyd=0
        exit function
    CASE WM_CHAR: char=wParam
        exit function
    CASE WM_MOUSEMOVE
        bselect=bselect OR 1
        mPosX = LOword(lParam)
        mPosY = HIword(lParam)
        if bleft=1 THEN
            x=mPosX: y=mPosY
            '' Depending on which view was selected, rotate around different axes
            SELECT CASE active_view
            CASE 1
                rot_x = rot_x + y - ypos
                rot_z = rot_z + x - xpos
            CASE 3
                rot_x = rot_x + y - ypos
                rot_y = rot_y + x - xpos
            CASE 4
                rot_y = rot_y + x - xpos
                rot_z = rot_z + y - ypos
            CASE ELSE
                '' Do nothing for perspective view, or if no view is selected
            END SELECT
            '' Remember mouse position
            xpos = x
            ypos = y
       end if
        exit function
    CASE WM_LBUTTONUP
        bLeft = 0:ePosX=mPosX:ePosY=mPosy
        '' Deselect any previously selected view
        active_view = 0
        exit function
    CASE WM_MBUTTONUP
        bMid = 0:ePosX=mPosX:ePosY=mPosy
        exit function
    CASE WM_RBUTTONUP
        bRight = 0:ePosX=mPosX:ePosY=mPosy
        exit function
    CASE WM_LBUTTONDOWN
        bLeft  = 1:sPosX=mPosX:sPosY=mPosy
        bSelect = bselect OR 2
        xpos = LOword(lParam)
        ypos = HIword(lParam)
        '' Detect which of the four views was clicked
        active_view = 1
        IF( xpos >= wwidth\2 ) THEN
            active_view+=1
        end if
        IF( ypos >= wheight\2 ) THEN
            active_view = active_view + 2
        end if
        'doredraw = TRUE
        exit function
    CASE WM_MBUTTONDOWN
        bMid  = 1:sPosX=mPosX:sPosY=mPosy
        bSelect = bselect OR 2
        exit function
    CASE WM_RBUTTONDOWN
        bRight = 1:sPosX=mPosX:sPosY=mPosY
        bSelect = bselect OR 2
        exit function
    CASE WM_MOUSEWHEEL
        bWheel = HIword(wParam)
        bselect=1
        exit function
    CASE WM_SIZE
        'Set the viewport to new dimensions
        wWidth=CLNG(LOword(lParam))
        wHeight=CLNG(HIword(lParam))
        glViewport 0, 0, wWidth, wHeight
        'viewport(0)=0:viewport(1)=0:viewport(2)=wWidth:viewport(3)=wHeight
        glMatrixMode &h1701 'GL_PROJECTION
        glLoadIdentity
        asm
          sub esp,32
          mov edx,esp
          mov   dword ptr [edx],45
          fild  dword ptr [edx]
          fstp  qword ptr [edx]
          fild  dword ptr [wwidth]
          fidiv dword ptr [wheight]
          fstp  qword ptr [edx+8]
          fld1
          fstp  qword ptr [edx+16]
          mov   dword ptr [edx+24],100
          fild  dword ptr [edx+24]
          fstp  qword ptr [edx+24]
          call gluperspective
        end asm
        'gluPerspective(45.0, wWidth/wHeight, 1.0, 100.0)
        glMatrixMode &h1700 ' GL_MODELVIEW
        'glGetDoublev GL_MODELVIEW_MATRIX, @modelview(0)
        'glGetDoublev GL_PROJECTION_MATRIX, @projection(0)
        refresh=1
        exit function

    CASE ELSE
        function = DefWindowProc(hWnd, wMsg, wParam, lParam)

    END SELECT
    exit function

terminate:
    if ReqShutDown<0 THEN exit function ' dont terminate
    KillTimer hWnd,1
    CLOSE
    glDeleteLists 1000, 255 ' font
    wglMakeCurrent hDC, NULL
    wglDeleteContext hRC
    ReleaseDC hWnd,hDC
    PostQuitMessage 0


end function


DECLARE function wglChooseP(BYVAL hDC AS LONG, iAttributes AS LONG, fAttributes AS SINGLE, BYVAL n AS LONG, pixelFormat AS LONG, numFormats AS LONG) AS LONG




sub change_screen_settings (sWidth AS LONG,sHeight AS LONG )
    dim dmScreenSettings AS DEVMODE
    dmScreenSettings.dmSize = SIZEOF(dmScreenSettings)
    dmScreenSettings.dmPelsWidth = sWidth
    dmScreenSettings.dmPelsHeight = sHeight
    dmScreenSettings.dmFields = DM_PELSWIDTH OR DM_PELSHEIGHT
    ChangeDisplaySettings @dmScreenSettings,CDS_FULLSCREEN
END sub

    dim shared wglChoosePixelFormatARB as function ( _
    byval hDC as HDC,byval ia as long ptr,byval as single ptr, bval as long, byval as long ptr, byval as long ptr ) as long


sub getstring(byval item as long,byval pz as zstring ptr)
    dim p as ubyte ptr
    p=glGetString(item)
    do
     *pz=*p
     if *p=0 then exit do
     pz+=1:p+=1
    loop
end sub

sub pgetstring(byval p as ubyte ptr,byval pz as zstring ptr)
    if p=0 then *pz=0:exit sub
    do
     *pz=*p
     if *p=0 then exit do
     pz+=1:p+=1
    loop
end sub


sub opengl_extensions(hDC AS HDC)
    dim AS ZSTRING*16384 s '=string$(1999,chr$(32))
    dim ss as string
    dim f  AS LONG:f=FREEFILE
    dim p  AS GLubyte PTR
    dim pa AS any PTR
    OPEN "OpenglAbility.txt" FOR OUTPUT AS f
    PRINT #f,"OPENGL on this PC:": PRINT #f,TIME$+"  "+DATE$:PRINT #f,""
    
    getstring(GL_VENDOR,@s)
    PRINT #f,    "Vendor:     " ; s
    getstring(GL_RENDERER,@s)
    PRINT #f,  "Renderer:   " ; s
    getstring(GL_VERSION,@s)
    PRINT #f,   "Version:    " ; s
    PRINT #f,""

'    'InitMultitexture()
'    'DIM params(15) AS dim GLint
'    'glGetIntegerv(GL_MAX_TEXTURE_UNITS_ARB, params(0))
'    'MaxTexelUnits=params(0)
'    'glMultiTexCoord2fARB = wglGetProcAddress("glMultiTexCoord2fARB")
'    'glActiveTextureARB   = wglGetProcAddress("glActiveTextureARB")
'    'PRINT #f,glMultiTexCoord2fARB,glActiveTextureARB, MaxTexelUnits
     GetString( GL_EXTENSIONS,@s)
     ' Check for necessary extensions
    if LEN(s)=0 THEN
        PRINT #f, "There are no Opengl Extensions available"
    ELSEIF (INSTR( s, "GL_ARB_depth_texture ")=0 ) OR ( INSTR (s, "GL_ARB_shadow ")=0) THEN
        PRINT #f, "I require ARB_depth_texture and ARB_shadow extensions so I cant do shadow mapping"
        shadows=0
    ELSE
        PRINT #f,"With ARB_depth_texture and ARB_shadow extensions I can do shadows"
        shadowAble=1
    end if
    if LEN(s) THEN
        PRINT #f,"":  PRINT #f,"EXTENSIONS SUPPORTED:": PRINT #f,""
        ss=s
        REPLACE(ss, " ",chr$(13)+chr$(10))        
        PRINT #f, ss
        pa=wglGetProcAddress("wglGetExtensionsStringARB")
        p=0
        if pa then
            asm
            call wglGetCurrentDC
            push eax
            call [pa]
            mov [p],eax
            end asm
        end if
        pgetstring(p,@s)
        if len(s) THEN
            'WGL_ARB_multisample
            ss=s
            if (INSTR(ss, "WGL_ARB_multisample ") )  THEN
                PRINT #f,"":PRINT #f,"I support ARBmultiSampling"
                multisampling=1
                wglGetProcAddress("wglChoosePixelFormatARB")
                asm mov [wglChoosePixelFormatARB],eax
                DIM iA(31) AS LONG
                ia(00)=WGL_DRAW_TO_WINDOW_ARB: ia(01)=GL_TRUE
                ia(02)=WGL_SUPPORT_OPENGL_ARB: ia(03)=GL_TRUE
                ia(04)=WGL_ACCELERATION_ARB:   ia(05)=WGL_FULL_ACCELERATION_ARB
                ia(06)=WGL_COLOR_BITS_ARB:     ia(07)=24
                ia(08)=WGL_ALPHA_BITS_ARB:     ia(09)=8
                ia(10)=WGL_DEPTH_BITS_ARB:     ia(11)=16
                ia(12)=WGL_STENCIL_BITS_ARB:   ia(13)=1
                ia(14)=WGL_DOUBLE_BUFFER_ARB:  ia(15)=GL_TRUE
                ia(16)=WGL_SAMPLE_BUFFERS_ARB: ia(17)=GL_TRUE
                ia(18)=WGL_SAMPLES_ARB:        ia(19)=4
                ia(20)=0:                      ia(21)=0
                '// First We Check To See if We Can Get A Pixel Format For 4 Samples
                '// Get Our Current Device Context
                dim valid AS LONG
                dim numFormats AS LONG
                DIM fAttributes(1) AS SINGLE
                dim pixelformat AS LONG
                ' hDC            Specifies the window associated with the device context.
                ' piAttribIList  Specifies the list of integer attributes in {type, value} pairs. The list is terminated with a type value of 0.
                ' pfAttribFList  Specifies the list of floating-point attributes in {type, value} pairs. The list is terminated with a type value of 0.0.
                ' nMaxFormats    Specifies the maximum number of pixel formats to be returned.
                ' piFormats      Points to an array of returned indices of the matching pixel formats. The closest matching formats are at the top of the list. The caller must allocated the array with at least nMaxFormats entries.
                ' nNumFormats    Returns the number of matching formats. This value may be larger than nMaxFormats
                  valid=wglChoosePixelFormatARB(hDC,@iA(0),@fAttributes(0),1,@pixelFormat,@numFormats)
                if pixelformat THEN
                    PRINT #f,"Pixel format for multisampling supported with mode: "+STR$(pixelformat)
                    arbMultisampleFormat=pixelFormat
                    arbMultisampleSupported=1
                ELSE
                    PRINT #f,"A Pixel format for multisampling could not be found"
                end if
            end if
            REPLACE(ss," ",chr$(13)+chr$(10))
            PRINT #f,"":  PRINT #f,"WGL EXTENSIONS SUPPORTED:": PRINT #f,""
            PRINT #f, ss
        end if
    end if
    CLOSE (f)
end sub



#ifdef glfonts
sub initialise_OpenGL (hWnd AS HWND, hDC AS HDC, hRC AS HGLRC)


    'BuildFont
    dim as long glFont AS LOGFONT, glFontHandle
    glFont.lfHeight         = -0.1                           'Height Of Font
    glFont.lfWeight         = FW_BOLD                       'Font Weight
    glFont.lfCharSet        = ANSI_CHARSET                  'Character Set Identifier
    glFont.lfOutPrecision   = OUT_TT_PRECIS                 'Output Precision
    glFont.lfClipPrecision  = CLIP_DEFAULT_PRECIS           'Clipping Precision
    glFont.lfQuality        = ANTIALIASED_QUALITY           'Output Quality
    glFont.lfPitchAndFamily = FF_DONTCARE OR DEFAULT_PITCH 'Family And Pitch
    glFont.lfFaceName       = "Arial" '"Comic Sans MS"       'Font Name
    glFontHandle = CreateFontIndirect(glFont)
    glFontHandle = SelectObject(hDC, glFontHandle)
    '
    wglUseFontOutlines hDC, 0, 255, 1000, 0.0, 0.2, WGL_FONT_POLYGONS, VARPTR(gmf(0))
    '
    DeleteObject SelectObject(hDC, glFontHandle)

end sub
#endif



function WINMAIN ALIAS "WinMain" ( _
    BYVAL hInstance     AS HINSTANCE, _
    BYVAL hPrevInstance AS HINSTANCE, _
    BYVAL lpCmdLine     AS zstring PTR, _
    BYVAL iCmdShow      AS LONG) _
    AS LONG export

    QueryPerformanceFrequency @freq


    dim wmsg       AS MSG
    dim wce       AS WNDCLASSEX
    dim ClassName AS zstring * 80
    dim ztitle    as zstring* 80
    dim hWnd      AS HWND
    dim tz as zstring ptr
    dim cz as zstring ptr
    cz=@Classname
    tz=@ztitle


    ztitle            = "OpenGL Split View Demo"
    ClassName         = "Split View"
    wce.cbSize        = SIZEOF(wce)
    wce.style         = CS_HREDRAW OR CS_VREDRAW
    wce.lpfnWndProc   = @WndProc
    wce.cbClsExtra    = 0
    wce.cbWndExtra    = 0
    wce.hInstance     = hInstance
    wce.hIcon         = LoadIcon(hInstance, "PBGL_EXAMPLE")
    wce.hCursor       = LoadCursor(NULL, BYVAL IDC_ARROW)
    wce.hbrBackground =GetStockObject (DKGRAY_BRUSH) ' NULL
    wce.lpszMenuName  = NULL
    wce.lpszClassName = VARPTR(ClassName)
    wce.hIconSm       = LoadIcon(hInstance, BYVAL IDI_APPLICATION)

    if RegisterClassEx(@wce)=FALSE THEN
        MessageBox 0,"Unable to Register Window Class.","Error",0
        exit function
    end if



    dim wstyle AS uinteger
    'wstyle=WS_SIZEBOX OR WS_CAPTION
    'wstyle=WS_POPUP or  WS_SIZEBOX
    'wstyle=WS_VISIBLE OR WS_SIZEBOX ' OR WS_POPUP '
    wstyle= WS_VISIBLE OR WS_OVERLAPPEDWINDOW


  asm
    mov eax,WS_VISIBLE
    or eax,WS_OVERLAPPEDWINDOW
    mov [wstyle],eax
      push 0          ' lp creation parameters
      push [hInstance]' prog instance
      push 0          ' menu handle
      push 0          ' parent window handle
      push 500        ' height
      push 500        ' width
      push 100        ' top
      push 100        ' left
      push [wstyle]   ' style
      push [tz]       ' window title
      push [cz]       ' classname
      push 0          ' extended style
    call CreateWindowEx
    mov [hWnd],eax
  end asm

    if hWnd = 0 THEN MessageBox 0,"Unable to create window","Error",0: exit function


    ' create

    'pre-emptive message if there is a failure
    dim fr AS LONG
    fr=FREEFILE:OPEN "OpenglAbility.txt" FOR OUTPUT AS fr:PRINT #fr,"Unable to use Opengl":CLOSE fr

    dim as long i,j
    dim as string stts=string$(1000," ")

    fr=FREEFILE:OPEN "settings.txt" FOR BINARY AS fr:GET$ #fr,1,stts:CLOSE fr
    stts=UCASE$(stts)+chr$(10): i=INSTR(stts,"MULTISAMPLING ")
    if i>0 THEN
        j=INSTR(i,stts,CHR$(10))
        if j>0 THEN
            i=INSTR(i+13,stts," ON"): if i>0 THEN if i<j THEN antialias=1
        end if
    end if

    hDC   = GetDC(hWnd)
    'setup pixel format


    dim pfd AS PIXELFORMATDESCRIPTOR

    pfd.nSize           = SIZEOF(PIXELFORMATDESCRIPTOR) 'Size of UDT structure
    pfd.nVersion        = 1                             'Version. Always set to 1.
    pfd.dwFlags         = PFD_DRAW_TO_WINDOW OR _      'Support Window
                          PFD_SUPPORT_OPENGL OR _      'Support OpenGL
                          PFD_DOUBLEBUFFER             'Support Double Buffering
    pfd.iPixelType      = PFD_TYPE_RGBA                'Red, Green, Blue, & Alpha Mode
    pfd.cColorBits      = 32                            '32-Bit Color Mode
    pfd.cRedBits        = NULL                         'Ignore Color and Shift Bits...
    pfd.cRedShift       = NULL                         '...
    pfd.cGreenBits      = NULL                         '...
    pfd.cGreenShift     = NULL                         '...
    pfd.cBlueBits       = NULL                         '...
    pfd.cBlueShift      = NULL                         '...
    pfd.cAlphaBits      = NULL                         'No Alpha Buffer
    pfd.cAlphaShift     = NULL                         'Ignore Shift Bit.
    pfd.cAccumBits      = NULL                         'No Accumulation Buffer
    pfd.cAccumRedBits   = NULL                         'Ignore Accumulation Bits...
    pfd.cAccumGreenBits = NULL                         '...
    pfd.cAccumBlueBits  = NULL                         '...
    pfd.cAccumAlphaBits = NULL                         '... Good Cereal! ;)
    pfd.cDepthBits      = 16                            ' bits z-buffer depth 8 16 24
    pfd.cStencilBits    = 1                             'Stencil Buffer
    pfd.cAuxBuffers     = NULL                         'No Auxiliary Buffer
    pfd.iLayerType      = PFD_MAIN_PLANE               'Main Drawing Plane
    pfd.bReserved       = NULL                         'Reserved
    pfd.dwLayerMask     = NULL                         'Ignore Layer Masks...
    pfd.dwVisibleMask   = NULL                         '...
    pfd.dwDamageMask    = NULL                         '...

    nPixelFormat = ChoosePixelFormat(hDC, @pfd) ' First without multisampling
    SetPixelFormat(hDC, nPixelFormat, @pfd)
    hRC = wglCreateContext (hDC)
    wglMakeCurrent hDC, hRC

  'opengl_extensions hDC
  'if (antiAlias<>0)AND(ArbMultisampleSupported<>0) THEN ReqNewMode=1    
  asm
    push hDC
    call Opengl_Extensions
      cmp dword ptr [antiAlias],0
      jz dcdpixm
      cmp dword ptr [ArbMultiSampleSupported],0
      jz dcdpixm
      mov dword ptr [ReqNewMode],1
    dcdpixm:
    cmp dword ptr [ReqNewMode],0
    jz pixmok
    '
    '
    push 0
    push [hdc]
    call wglMakeCurrent
    push [hRc]
    call wglDeleteContext
    push [hDC]
    push [hWnd]
    call ReleaseDC
    mov dword ptr ReqShutdown, -1
    push [hWnd]
    call DestroyWindow
    mov dword ptr ReqShutdown,0
    ' then recreate new window with multisampling ability
    mov eax,WS_VISIBLE
    or eax,WS_OVERLAPPEDWINDOW
    mov [wstyle],eax
      push 0
      push [hInstance]
      push 0
      push 0
      push 500
      push 500
      push 100
      push 100
      push [wstyle]
      push [tz]
      push [cz]
      push 0
    call CreateWindowEx
    mov [hWnd],eax
    cmp eax,0
    jnz hwok
  end asm 
  MessageBox 0,"Unable to create window","Error",0: exit function
  asm   
    hwok:
    push [hwnd]
    call GetDC
    mov [hDC],eax
    lea eax,[pfd]
    push eax
    push [ArbMultiSampleFormat]
    push [hDC]
    call SetPixelFormat
    push [hDC]
    call wglCreateContext
    mov hRC,eax
    push eax
    push hDC
    call wglMakeCurrent
    '------
    'initialise_OpenGL(hWnd,hDC,hRC)
    '------
    pixmok:
    '------
    'iCmdShow=SW_NORMAL
    'ShowWindow hWnd, iCmdShow
    'UpdateWindow hWnd
    mov dword ptr [ReqNewMode],0
    push 0
    push 10
    push 1
    push [hWnd]
    call SetTimer
    '
    lea edi,[wMsg]
    msgloop: '-----------------MESSAGE LOOP
      push 0
      push 0
      push 0
      push edi
      call GetMessage
      cmp eax,0
      jz xmsgloop
      push edi
      call TranslateMessage
      push edi
      call DispatchMessage
    jmp msgloop
    xmsgloop:
    '
    '
    lea eax,[wMsg]
    add eax,8
    mov eax,[eax]
    mov [function],eax
  end asm
    
end function

end WinMain( GetModuleHandle( null ), null, Command( ), SW_NORMAL )
