

''========================================================================

'' 
'' Derived From FreeBasic 0.18.3 distr GL example SplitView
'' Rewritten using only Windows SDK and OpenGL
'' to work smoothly on Vista
'' Supports AntiAliasing if available
'' (PowerBasic 8.04 translatiob also available)
''
'' Charles E V Pegge 07:40 04 March 2008


'' original notes:
''========================================================================
'' T*=
'' The program uses a "split window" view, rendering four views of the
'' same scene in one window (e.g. uesful for 3D modelling software). This
'' demo uses scissors to separete the four different rendering areas from
'' each other.
''
'' (If the code seems a little bit strange here and there, it may be
''  because I am not a friend of orthogonal projections)
''========================================================================


    #INCLUDE "WINDOWS.BI"
    #INCLUDE "GL\GL.BI"
    #INCLUDE "GL\GLEXT.BI"
    #INCLUDE "GL\GLU.BI"

    #define NULL 0
    #define FALSE 0
'    #define TRUE -1
    #define PI 3.14159265358979323846




' ARB Extensions

'Sep 2006
#define WGL_NUMBER_PIXEL_FORMATS_ARB      &h2000
#define WGL_DRAW_TO_WINDOW_ARB            &h2001
#define WGL_DRAW_TO_BITMAP_ARB            &h2002
#define WGL_ACCELERATION_ARB              &h2003
#define WGL_NEED_PALETTE_ARB              &h2004
#define WGL_NEED_SYSTEM_PALETTE_ARB       &h2005
#define WGL_SWAP_LAYER_BUFFERS_ARB        &h2006
#define WGL_SWAP_METHOD_ARB               &h2007
#define WGL_NUMBER_OVERLAYS_ARB           &h2008
#define WGL_NUMBER_UNDERLAYS_ARB          &h2009
#define WGL_TRANSPARENT_ARB               &h200A
#define WGL_TRANSPARENT_RED_VALUE_ARB     &h2037
#define WGL_TRANSPARENT_GREEN_VALUE_ARB   &h2038
#define WGL_TRANSPARENT_BLUE_VALUE_ARB    &h2039
#define WGL_TRANSPARENT_ALPHA_VALUE_ARB   &h203A
#define WGL_TRANSPARENT_INDEX_VALUE_ARB   &h203B
#define WGL_SHARE_DEPTH_ARB               &h200C
#define WGL_SHARE_STENCIL_ARB             &h200D
#define WGL_SHARE_ACCUM_ARB               &h200E
#define WGL_SUPPORT_GDI_ARB               &h200F
#define WGL_SUPPORT_OPENGL_ARB            &h2010
#define WGL_DOUBLE_BUFFER_ARB             &h2011
#define WGL_STEREO_ARB                    &h2012
#define WGL_PIXEL_TYPE_ARB                &h2013
#define WGL_COLOR_BITS_ARB                &h2014
#define WGL_RED_BITS_ARB                  &h2015
#define WGL_RED_SHIFT_ARB                 &h2016
#define WGL_GREEN_BITS_ARB                &h2017
#define WGL_GREEN_SHIFT_ARB               &h2018
#define WGL_BLUE_BITS_ARB                 &h2019
#define WGL_BLUE_SHIFT_ARB                &h201A
#define WGL_ALPHA_BITS_ARB                &h201B
#define WGL_ALPHA_SHIFT_ARB               &h201C
#define WGL_ACCUM_BITS_ARB                &h201D
#define WGL_ACCUM_RED_BITS_ARB            &h201E
#define WGL_ACCUM_GREEN_BITS_ARB          &h201F
#define WGL_ACCUM_BLUE_BITS_ARB           &h2020
#define WGL_ACCUM_ALPHA_BITS_ARB          &h2021
#define WGL_DEPTH_BITS_ARB                &h2022
#define WGL_STENCIL_BITS_ARB              &h2023
#define WGL_AUX_BUFFERS_ARB               &h2024
#define WGL_NO_ACCELERATION_ARB           &h2025
#define WGL_GENERIC_ACCELERATION_ARB      &h2026
#define WGL_FULL_ACCELERATION_ARB         &h2027
#define WGL_SWAP_EXCHANGE_ARB             &h2028
#define WGL_SWAP_COPY_ARB                 &h2029
#define WGL_SWAP_UNDEFINED_ARB            &h202A
#define WGL_TYPE_RGBA_ARB                 &h202B
#define WGL_TYPE_COLORINDEX_ARB           &h202C
#define WGL_SAMPLE_BUFFERS_ARB            &h2041
#define WGL_SAMPLES_ARB                   &h2042

#define GL_MULTISAMPLE_ARB                &h809D
#define GL_SAMPLE_ALPHA_TO_COVERAGE_ARB   &h809E
#define GL_SAMPLE_ALPHA_TO_ONE_ARB        &h809F
#define GL_SAMPLE_COVERAGE_ARB            &h80A0
#define GL_SAMPLE_BUFFERS_ARB             &h80A8
#define GL_SAMPLES_ARB                    &h80A9
#define GL_SAMPLE_COVERAGE_VALUE_ARB      &h80AA
#define GL_SAMPLE_COVERAGE_INVERT_ARB     &h80AB


' ARB extension needed for for shadow mapping

#define GL_DEPTH_TEXTURE_MODE_ARB         &h884B

#define GL_TEXTURE_COMPARE_MODE_ARB       &h884C
#define GL_TEXTURE_COMPARE_FUNC_ARB       &h884D
#define GL_COMPARE_R_TO_TEXTURE_ARB       &h884E

' Opengl 1.4
#define GL_COMPARE_R_TO_TEXTURE           &h884E


'#define WGL_SUPPORT_OPENGL_ARB            &h2010


''========================================================================
'' Global variables
''========================================================================

    dim shared as LARGE_INTEGER grtic1,grtic2,freq
    dim shared as double fps,grlap
    dim shared as long   refresh,bselect,kselect,keyd,char,ReqShutDown
    dim shared as long   bLeft,bMid,bRight,bWheel
    dim shared as long   sposx,sposy,mposx,mposy,eposx,eposy
    dim shared as long   wWidth,wHeight
    dim shared as HDC hDC
    dim shared as HGLRC hRC
    dim shared as long   shadows,shadowable
    dim shared as long   antialias, multisampling
    dim shared as long   nPixelFormat,ReqNewMode,arbMultisampleFormat, arbMultisampleSupported
    dim shared as long   timerval

''========================================================================
    dim shared as long doredraw
    '' Mouse position
    dim shared as long xpos, ypos
    '' Window size wWidth wHeight
    '' Active view: 0 = none, 1 = upper left, 2 = upper right, 3 = lower left,
    '' 4 = lower right
    dim shared as long active_view
    '' Rotation around each axis
    dim shared as long rot_x, rot_y, rot_z

''========================================================================



''========================================================================
'' replace a substring with another substring throughout a string
''========================================================================
sub replace(s as string, f as string, r as string)
    dim as long i,j,k,l,m
    l=len(f)
    m=len(r)
    i=1
    do
     i=instr(i,s,f)
     if i=0 then exit do
     s=left$(s,i-1)+r+mid$(s,i+l)
     i+=m
    loop
end sub



''========================================================================
'' DrawTorus() - Draw a solid torus (use a display list for the model)
''========================================================================

#define TORUS_MAJOR     1.5
#define TORUS_MINOR     0.5
#define TORUS_MAJOR_RES  32
#define TORUS_MINOR_RES  32

sub DrawTorus( )
    STATIC as uinteger torus_list
    dim as long i, j, k
    dim as double s, t, x, y, z, nx, ny, nz, gscale, twopi
    IF( torus_list = 0 ) THEN
        '' Start recording displaylist
        torus_list = glGenLists( 1 )
        glNewList( torus_list, GL_COMPILE_AND_EXECUTE )

        '' Draw torus
        twopi = 2.0 * PI
        FOR i = 0 TO TORUS_MINOR_RES-1
            glBegin( GL_QUAD_STRIP )
            FOR j = 0 TO TORUS_MAJOR_RES
                FOR k = 1 TO 0 STEP -1
                    s = (i + k) MOD TORUS_MINOR_RES + 0.5
                    t = j MOD TORUS_MAJOR_RES

                    '' Calculate point on surface
                    x = (TORUS_MAJOR+TORUS_MINOR*COS(s*twopi/TORUS_MINOR_RES))*COS(t*twopi/TORUS_MAJOR_RES)
                    y = TORUS_MINOR * SIN(s * twopi / TORUS_MINOR_RES)
                    z = (TORUS_MAJOR+TORUS_MINOR*COS(s*twopi/TORUS_MINOR_RES))*SIN(t*twopi/TORUS_MAJOR_RES)

                    '' Calculate surface normal
                    nx = x - TORUS_MAJOR*COS(t*twopi/TORUS_MAJOR_RES)
                    ny = y
                    nz = z - TORUS_MAJOR*SIN(t*twopi/TORUS_MAJOR_RES)
                    gscale = 1.0 / SQR( nx*nx + ny*ny + nz*nz )
                    nx = nx*gscale
                    ny = ny*gscale
                    nz = nz*gscale

                    glNormal3f( nx, ny, nz )
                    glVertex3f( x, y, z )
                NEXT
            NEXT
            glEnd()
        NEXT

        '' Stop recording displaylist
        glEndList()
    ELSE
        '' Playback displaylist
        glCallList( torus_list )
    end if
end sub


''========================================================================
'' DrawScene() - Draw the scene (a rotating torus)
''========================================================================

sub DrawScene(  )
    static as single model_diffuse(0 TO 3)  => { 1.0, 0.8, 0.8, 1.0 }
    static as single model_specular(0 TO 3) => { 0.6, 0.6, 0.6, 1.0 }
    static as single model_shininess = 20.0

    glPushMatrix( )

    '' Rotate the object
    glRotatef( rot_x*0.5, 1.0, 0.0, 0.0 )
    glRotatef( rot_y*0.5, 0.0, 1.0, 0.0 )
    glRotatef( rot_z*0.5, 0.0, 0.0, 1.0 )

    '' Set model color (used for orthogonal views, lighting disabled)
    glColor4fv( @model_diffuse(0) )

    '' Set model material (used for perspective view, lighting enabled)
    glMaterialfv( GL_FRONT, GL_DIFFUSE, @model_diffuse(0) )
    glMaterialfv( GL_FRONT, GL_SPECULAR, @model_specular(0) )
    glMaterialf(  GL_FRONT, GL_SHININESS, model_shininess )

    '' Draw torus
    DrawTorus()

    glPopMatrix()
end sub


''========================================================================
'' DrawGrid() - Draw a 2D grid (used for orthogonal views)
''========================================================================

sub DrawGrid( BYVAL gscale AS SINGLE, BYVAL gsteps AS INTEGER )
    dim as long i
    dim as single x, y

    glPushMatrix( )

    '' Set background to some dark bluish grey
    glClearColor( 0.05, 0.05, 0.2, 0.0)
    glClear( GL_COLOR_BUFFER_BIT )

    '' Setup modelview matrix (flat XY view)
    glLoadIdentity( )
    gluLookAt( 0.0, 0.0, 1.0, _
               0.0, 0.0, 0.0, _
               0.0, 1.0, 0.0 )

    '' We don't want to update the Z-buffer
    glDepthMask( GL_FALSE )

    '' Set grid color
    glDisable GL_LIGHTING
    glColor3f( 0.0, 0.5, 0.5 )

    glBegin( GL_LINES )

    '' Horizontal lines
    x = gscale * 0.5 * (gsteps-1)
    y = -gscale * 0.5 * (gsteps-1)
    FOR i = 0 TO gsteps-1
        glVertex3f( -x, y, 0.0 )
        glVertex3f( x, y, 0.0 )
        y = y + gscale
    NEXT

    '' Vertical lines
    x = -gscale * 0.5 * (gsteps-1)
    y = gscale * 0.5 * (gsteps-1)
    FOR i = 0 TO gsteps-1
        glVertex3f( x, -y, 0.0 )
        glVertex3f( x, y, 0.0 )
        x = x + gscale
    NEXT

    glEnd()

    '' Enable Z-buffer writing again
    glDepthMask( GL_TRUE )

    glPopMatrix()
end sub


''========================================================================
'' DrawAllViews()
''========================================================================

sub DrawAllViews( )
    static as single light_position(0 TO 3) =>  { 0.0, 8.0, 8.0, 1.0 }
    static as single light_diffuse(0 TO 3)  =>  { 1.0, 1.0, 1.0, 1.0 }
    static as single light_specular(0 TO 3) =>  { 1.0, 1.0, 1.0, 1.0 }
    static as single light_ambient(0 TO 3)  =>  { 0.2, 0.2, 0.3, 1.0 }
    static as double aspect

    '' Calculate aspect of window
    IF( wheight > 0 ) THEN
        aspect = wwidth / wheight
    ELSE
        aspect = 1.0
    end if

    '' Clear screen
    glClearColor( 0.0, 0.0, 0.0, 0.0 )
    glClear( GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT )

    '' Enable scissor test
    glEnable( GL_SCISSOR_TEST )

    '' Enable depth test
    glEnable( GL_DEPTH_TEST )
    glDepthFunc( GL_LEQUAL )


    '' ** ORTHOGONAL VIEWS **

    '' For orthogonal views, use wireframe rendering
    glPolygonMode( GL_FRONT_AND_BACK, GL_LINE )

    '' Enable line anti-aliasing
    glEnable( GL_LINE_SMOOTH )
    glEnable( GL_BLEND )
    glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA )

    '' Setup orthogonal projection matrix
    glMatrixMode( GL_PROJECTION )
    glLoadIdentity( )
    glOrtho( -3.0*aspect, 3.0*aspect, -3.0, 3.0, 1.0, 50.0 )

    '' Upper left view (TOP VIEW)
    glViewport( 0, wheight\2, wwidth\2, wheight\2 )
    glScissor( 0, wheight\2, wwidth\2, wheight\2 )
    glMatrixMode( GL_MODELVIEW )
    glLoadIdentity()
    gluLookAt( 0.0, 10.0, 1e-3, _  '' Eye-position (above)
               0.0, 0.0, 0.0,   _  '' View-point
               0.0, 1.0, 0.0 )     '' Up-vector
    DrawGrid( 0.5, 12 )
    DrawScene( )

    '' Lower left view (FRONT VIEW)
    glViewport( 0, 0, wwidth\2, wheight\2 )
    glScissor( 0, 0, wwidth\2, wheight\2 )
    glMatrixMode( GL_MODELVIEW )
    glLoadIdentity( )
    gluLookAt( 0.0, 0.0, 10.0, _   '' Eye-position (in front of)
               0.0, 0.0, 0.0,  _   '' View-point
               0.0, 1.0, 0.0 )     '' Up-vector
    DrawGrid( 0.5, 12 )
    DrawScene()

    '' Lower right view (SIDE VIEW)
    glViewport( wwidth\2, 0, wwidth\2, wheight\2 )
    glScissor( wwidth\2, 0, wwidth\2, wheight\2 )
    glMatrixMode( GL_MODELVIEW )
    glLoadIdentity()
    gluLookAt( 10.0, 0.0, 0.0, _   '' Eye-position (to the right)
               0.0, 0.0, 0.0,  _   '' View-point
               0.0, 1.0, 0.0 )     '' Up-vector
    DrawGrid( 0.5, 12 )
    DrawScene( )

    '' Disable line anti-aliasing
    glDisable( GL_LINE_SMOOTH )
    glDisable( GL_BLEND )


    '' ** PERSPECTIVE VIEW **

    '' For perspective view, use solid rendering
    glPolygonMode( GL_FRONT_AND_BACK, GL_FILL )

    '' Enable face culling (faster rendering)
    glEnable( GL_CULL_FACE )
    glCullFace( GL_BACK )
    glFrontFace( GL_CW )

    '' Setup perspective projection matrix
    glMatrixMode( GL_PROJECTION )
    glLoadIdentity( )
    gluPerspective( 65.0, aspect, 1.0, 50.0 )

    '' Upper right view (PERSPECTIVE VIEW)
    glViewport( wwidth\2, wheight\2, wwidth\2, wheight\2 )
    glScissor( wwidth\2, wheight\2, wwidth\2, wheight\2 )
    glMatrixMode( GL_MODELVIEW )
    glLoadIdentity()
    gluLookAt( 3.0, 1.5, 3.0, _    '' Eye-position
               0.0, 0.0, 0.0, _    '' View-point
               0.0, 1.0, 0.0 )     '' Up-vector

    '' Configure and enable light source 1
    glLightfv( GL_LIGHT1, GL_POSITION, @light_position(0) )
    glLightfv( GL_LIGHT1, GL_AMBIENT, @light_ambient(0) )
    glLightfv( GL_LIGHT1, GL_DIFFUSE, @light_diffuse(0) )
    glLightfv( GL_LIGHT1, GL_SPECULAR, @light_specular(0) )
    glEnable( GL_LIGHT1 )
    glEnable( GL_LIGHTING )

    '' Draw scene
    DrawScene( )

    '' Disable lighting
    glDisable( GL_LIGHTING )

    '' Disable face culling
    glDisable( GL_CULL_FACE )

    '' Disable depth test
    glDisable( GL_DEPTH_TEST )

    '' Disable scissor test
    glDisable( GL_SCISSOR_TEST )


    '' Draw a border around the active view
    IF( active_view > 0 AND active_view <> 2 ) THEN
        glViewport( 0, 0, wwidth, wheight )
        glMatrixMode( GL_PROJECTION )
        glLoadIdentity()
        glOrtho( 0.0, 2.0, 0.0, 2.0, 0.0, 1.0 )
        glMatrixMode( GL_MODELVIEW )
        glLoadIdentity()
        glColor3f( 1.0, 1.0, 0.6 )
        glTranslatef( (active_view-1) AND 1, 1-(active_view-1)\2, 0.0 )
        glBegin( GL_LINE_STRIP )
          glVertex2i( 0, 0 )
          glVertex2i( 1, 0 )
          glVertex2i( 1, 1 )
          glVertex2i( 0, 1 )
          glVertex2i( 0, 0 )
        glEnd()
    end if
end sub




sub do_the_next_frame(BYVAL hWnd AS HWND )  ' construct each frame
                                              '
    STATIC firstframe AS LONG
    static shro AS LONG
    static shrt AS SINGLE
    static shre AS SINGLE

    static as long signal = 0

    ' timing
    QueryPerformanceCounter @grtic2
    'grlap=(1e6*(grtic2-grtic1)/freq)
    fps=0.99*fps+10000/grlap ' moving average frames per sec

    ' screen refresh
    if bselect+kselect+refresh=0 THEN grtic1=grtic2: GOTO xdo_frame ' no need to update frame
    refresh=0

    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)

    '=============
    DrawAllViews()
    '=============
    glFinish   ' wait until all operations complete
    SwapBuffers HDC

    'IF firstframe=0 THEN SetWindowPos hWnd,HWND_TOP,100,100,500,500,0: firstframe=1
    grtic1=grtic2
xdo_frame:

    exit sub
                                              '
end sub                                    '



dim shared keys(255) AS LONG
dim shared mapref(15) AS LONG
dim shared cameraProjectionMatrix(15) AS SINGLE
dim shared modelview(15) AS DOUBLE
dim shared projection(15) AS DOUBLE


function WndProc ( byval hWnd as HWND, _
                   byval wMsg as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT


    dim gmf(255) AS  GLYPHMETRICSFLOAT
    dim viewport(3) AS LONG

    dim as long i,j
    dim as long x,y,z

    if wmsg=wm_paint THEN refresh=1

    SELECT CASE wMsg

    CASE WM_ACTIVATE
        if HIword(wParam) THEN exit function
     CASE WM_DESTROY
        GOTO terminate
     CASE WM_TIMER
         if wParam=1 THEN
             do_the_next_frame (hWnd)
            if ReqShutDown THEN goto terminate
        end if
        exit function
    CASE WM_KEYDOWN
        wParam=wParam AND 255
        keys(wParam) = 1: keyd=wParam: kselect=wParam
        if wParam=VK_ESCAPE THEN ReqShutdown=1: exit function
        if (wParam>=VK_F1)AND(wParam<=VK_F12) THEN
            '..
        end if
        exit function
    CASE WM_KEYUP
        wParam=wParam AND 255
        keys(wParam) = 0:keyd=0
        exit function
    CASE WM_CHAR: char=wParam
        exit function
    CASE WM_MOUSEMOVE
        bselect=bselect OR 1
        mPosX = LOword(lParam)
        mPosY = HIword(lParam)
        if bleft=1 THEN
            x=mPosX: y=mPosY
            '' Depending on which view was selected, rotate around different axes
            SELECT CASE active_view
            CASE 1
                rot_x = rot_x + y - ypos
                rot_z = rot_z + x - xpos
            CASE 3
                rot_x = rot_x + y - ypos
                rot_y = rot_y + x - xpos
            CASE 4
                rot_y = rot_y + x - xpos
                rot_z = rot_z + y - ypos
            CASE ELSE
                '' Do nothing for perspective view, or if no view is selected
            END SELECT
            '' Remember mouse position
            xpos = x
            ypos = y
       end if
        exit function
    CASE WM_LBUTTONUP
        bLeft = 0:ePosX=mPosX:ePosY=mPosy
        '' Deselect any previously selected view
        active_view = 0
        exit function
    CASE WM_MBUTTONUP
        bMid = 0:ePosX=mPosX:ePosY=mPosy
        exit function
    CASE WM_RBUTTONUP
        bRight = 0:ePosX=mPosX:ePosY=mPosy
        exit function
    CASE WM_LBUTTONDOWN
        bLeft  = 1:sPosX=mPosX:sPosY=mPosy
        bSelect = bselect OR 2
        xpos = LOword(lParam)
        ypos = HIword(lParam)
        '' Detect which of the four views was clicked
        active_view = 1
        IF( xpos >= wwidth\2 ) THEN
            active_view+=1
        end if
        IF( ypos >= wheight\2 ) THEN
            active_view = active_view + 2
        end if
        doredraw = TRUE
        exit function
    CASE WM_MBUTTONDOWN
        bMid  = 1:sPosX=mPosX:sPosY=mPosy
        bSelect = bselect OR 2
        exit function
    CASE WM_RBUTTONDOWN
        bRight = 1:sPosX=mPosX:sPosY=mPosY
        bSelect = bselect OR 2
        exit function
    CASE WM_MOUSEWHEEL
        bWheel = HIword(wParam)
        bselect=1
        exit function
    CASE WM_SIZE
        'Set the viewport to new dimensions
        wWidth=CLNG(LOword(lParam))
        wHeight=CLNG(HIword(lParam))
        glViewport 0, 0, wWidth, wHeight
        viewport(0)=0:viewport(1)=0:viewport(2)=wWidth:viewport(3)=wHeight
        glMatrixMode GL_PROJECTION
        glLoadIdentity
        gluPerspective(45.0, wWidth/wHeight, 1.0, 100.0)
        glMatrixMode GL_MODELVIEW
        glGetDoublev GL_MODELVIEW_MATRIX, @modelview(0)
        glGetDoublev GL_PROJECTION_MATRIX, @projection(0)
        refresh=1
        exit function

    CASE ELSE
        function = DefWindowProc(hWnd, wMsg, wParam, lParam)

    END SELECT
    exit function

terminate:
    if ReqShutDown<0 THEN exit function ' dont terminate
    KillTimer hWnd,1
    CLOSE
    glDeleteLists 1000, 255 ' font
    wglMakeCurrent hDC, NULL
    wglDeleteContext hRC
    ReleaseDC hWnd,hDC
    PostQuitMessage 0


end function


DECLARE function wglChooseP(BYVAL hDC AS LONG, iAttributes AS LONG, fAttributes AS SINGLE, BYVAL n AS LONG, pixelFormat AS LONG, numFormats AS LONG) AS LONG

sub change_screen_settings (sWidth AS LONG,sHeight AS LONG )
    dim dmScreenSettings AS DEVMODE
    dmScreenSettings.dmSize = SIZEOF(dmScreenSettings)
    dmScreenSettings.dmPelsWidth = sWidth
    dmScreenSettings.dmPelsHeight = sHeight
    dmScreenSettings.dmFields = DM_PELSWIDTH OR DM_PELSHEIGHT
    ChangeDisplaySettings @dmScreenSettings,CDS_FULLSCREEN
END sub

    dim shared wglChoosePixelFormatARB as function ( _
    byval hDC as HDC,byval ia as long ptr,byval as single ptr, bval as long, byval as long ptr, byval as long ptr ) as long


sub getstring(byval item as long,byval pz as zstring ptr)
    dim p as ubyte ptr
    p=glGetString(item)
    do
     *pz=*p
     if *p=0 then exit do
     pz+=1:p+=1
    loop
end sub

sub pgetstring(byval p as ubyte ptr,byval pz as zstring ptr)
    if p=0 then *pz=0:exit sub
    do
     *pz=*p
     if *p=0 then exit do
     pz+=1:p+=1
    loop
end sub


sub opengl_extensions(hDC AS HDC)
    dim AS ZSTRING*16384 s '=string$(1999,chr$(32))
    dim ss as string
    dim f  AS LONG:f=FREEFILE
    dim p  AS GLubyte PTR
    dim pa AS any PTR
    OPEN "OpenglAbility.txt" FOR OUTPUT AS f
    PRINT #f,"OPENGL on this PC:": PRINT #f,TIME$+"  "+DATE$:PRINT #f,""
    
    getstring(GL_VENDOR,@s)
    PRINT #f,    "Vendor:     " ; s
    getstring(GL_RENDERER,@s)
    PRINT #f,  "Renderer:   " ; s
    getstring(GL_VERSION,@s)
    PRINT #f,   "Version:    " ; s
    PRINT #f,""

'    'InitMultitexture()
'    'DIM params(15) AS dim GLint
'    'glGetIntegerv(GL_MAX_TEXTURE_UNITS_ARB, params(0))
'    'MaxTexelUnits=params(0)
'    'glMultiTexCoord2fARB = wglGetProcAddress("glMultiTexCoord2fARB")
'    'glActiveTextureARB   = wglGetProcAddress("glActiveTextureARB")
'    'PRINT #f,glMultiTexCoord2fARB,glActiveTextureARB, MaxTexelUnits
     GetString( GL_EXTENSIONS,@s)
     ' Check for necessary extensions
    if LEN(s)=0 THEN
        PRINT #f, "There are no Opengl Extensions available"
    ELSEIF (INSTR( s, "GL_ARB_depth_texture ")=0 ) OR ( INSTR (s, "GL_ARB_shadow ")=0) THEN
        PRINT #f, "I require ARB_depth_texture and ARB_shadow extensions so I cant do shadow mapping"
        shadows=0
    ELSE
        PRINT #f,"With ARB_depth_texture and ARB_shadow extensions I can do shadows"
        shadowAble=1
    end if
    if LEN(s) THEN
        PRINT #f,"":  PRINT #f,"EXTENSIONS SUPPORTED:": PRINT #f,""
        ss=s
        REPLACE(ss, " ",chr$(13)+chr$(10))        
        PRINT #f, ss
        pa=wglGetProcAddress("wglGetExtensionsStringARB")
        p=0
        if pa then
            asm
            call wglGetCurrentDC
            push eax
            call [pa]
            mov [p],eax
            end asm
        end if
        pgetstring(p,@s)
        if len(s) THEN
            'WGL_ARB_multisample
            ss=s
            if (INSTR(ss, "WGL_ARB_multisample ") )  THEN
                PRINT #f,"":PRINT #f,"I support ARBmultiSampling"
                multisampling=1
                wglGetProcAddress("wglChoosePixelFormatARB")
                asm mov [wglChoosePixelFormatARB],eax
                DIM iA(31) AS LONG
                ia(00)=WGL_DRAW_TO_WINDOW_ARB: ia(01)=GL_TRUE
                ia(02)=WGL_SUPPORT_OPENGL_ARB: ia(03)=GL_TRUE
                ia(04)=WGL_ACCELERATION_ARB:   ia(05)=WGL_FULL_ACCELERATION_ARB
                ia(06)=WGL_COLOR_BITS_ARB:     ia(07)=24
                ia(08)=WGL_ALPHA_BITS_ARB:     ia(09)=8
                ia(10)=WGL_DEPTH_BITS_ARB:     ia(11)=16
                ia(12)=WGL_STENCIL_BITS_ARB:   ia(13)=1
                ia(14)=WGL_DOUBLE_BUFFER_ARB:  ia(15)=GL_TRUE
                ia(16)=WGL_SAMPLE_BUFFERS_ARB: ia(17)=GL_TRUE
                ia(18)=WGL_SAMPLES_ARB:        ia(19)=4
                ia(20)=0:                      ia(21)=0
                '// First We Check To See if We Can Get A Pixel Format For 4 Samples
                '// Get Our Current Device Context
                dim valid AS LONG
                dim numFormats AS LONG
                DIM fAttributes(1) AS SINGLE
                dim pixelformat AS LONG
                ' hDC            Specifies the window associated with the device context.
                ' piAttribIList  Specifies the list of integer attributes in {type, value} pairs. The list is terminated with a type value of 0.
                ' pfAttribFList  Specifies the list of floating-point attributes in {type, value} pairs. The list is terminated with a type value of 0.0.
                ' nMaxFormats    Specifies the maximum number of pixel formats to be returned.
                ' piFormats      Points to an array of returned indices of the matching pixel formats. The closest matching formats are at the top of the list. The caller must allocated the array with at least nMaxFormats entries.
                ' nNumFormats    Returns the number of matching formats. This value may be larger than nMaxFormats
                  valid=wglChoosePixelFormatARB(hDC,@iA(0),@fAttributes(0),1,@pixelFormat,@numFormats)
                if pixelformat THEN
                    PRINT #f,"Pixel format for multisampling supported with mode: "+STR$(pixelformat)
                    arbMultisampleFormat=pixelFormat
                    arbMultisampleSupported=1
                ELSE
                    PRINT #f,"A Pixel format for multisampling could not be found"
                end if
            end if
            REPLACE(ss," ",chr$(13)+chr$(10))
            PRINT #f,"":  PRINT #f,"WGL EXTENSIONS SUPPORTED:": PRINT #f,""
            PRINT #f, ss
        end if
    end if
    CLOSE (f)
end sub




sub initialise_OpenGL (hWnd AS HWND, hDC AS HDC, hRC AS HGLRC)


'    'BuildFont
'    dim as long glFont AS LOGFONT, glFontHandle
'    glFont.lfHeight         = -0.1                           'Height Of Font
'    glFont.lfWeight         = FW_BOLD                       'Font Weight
'    glFont.lfCharSet        = ANSI_CHARSET                  'Character Set Identifier
'    glFont.lfOutPrecision   = OUT_TT_PRECIS                 'Output Precision
'    glFont.lfClipPrecision  = CLIP_DEFAULT_PRECIS           'Clipping Precision
'    glFont.lfQuality        = ANTIALIASED_QUALITY           'Output Quality
'    glFont.lfPitchAndFamily = FF_DONTCARE OR DEFAULT_PITCH 'Family And Pitch
'    glFont.lfFaceName       = "Arial" '"Comic Sans MS"       'Font Name
'    glFontHandle = CreateFontIndirect(glFont)
'    glFontHandle = SelectObject(hDC, glFontHandle)
'    '
'    wglUseFontOutlines hDC, 0, 255, 1000, 0.0, 0.2, WGL_FONT_POLYGONS, VARPTR(gmf(0))
'    '
'    DeleteObject SelectObject(hDC, glFontHandle)

end sub






function WINMAIN ALIAS "WinMain" ( _
    BYVAL hInstance     AS HINSTANCE, _
    BYVAL hPrevInstance AS HINSTANCE, _
    BYVAL lpCmdLine     AS zstring PTR, _
    BYVAL iCmdShow      AS LONG) _
    AS LONG export

    QueryPerformanceFrequency @freq


    dim wmsg       AS MSG
    dim wce       AS WNDCLASSEX
    dim ClassName AS zstring * 80
    dim hWnd      AS HWND


    ClassName         = "Split View"
    wce.cbSize        = SIZEOF(wce)
    wce.style         = CS_HREDRAW OR CS_VREDRAW
    wce.lpfnWndProc   = @WndProc
    wce.cbClsExtra    = 0
    wce.cbWndExtra    = 0
    wce.hInstance     = hInstance
    wce.hIcon         = LoadIcon(hInstance, "PBGL_EXAMPLE")
    wce.hCursor       = LoadCursor(NULL, BYVAL IDC_ARROW)
    wce.hbrBackground = NULL
    wce.lpszMenuName  = NULL
    wce.lpszClassName = VARPTR(ClassName)
    wce.hIconSm       = LoadIcon(hInstance, BYVAL IDI_APPLICATION)

    if RegisterClassEx(@wce)=FALSE THEN
        MessageBox 0,"Unable to Register Window Class.","Error",0
        exit function
    end if



    dim wstyle AS uinteger
    wstyle=WS_SIZEBOX OR WS_CAPTION
    'wstyle=WS_POPUP or  WS_SIZEBOX
    'wstyle=WS_VISIBLE OR WS_SIZEBOX ' OR WS_POPUP '
    'wstyle= WS_VISIBLE OR WS_OVERLAPPEDWINDOW
    hWnd = CreateWindowEx(NULL,_
    ClassName,_
    "OpenGL Split View Demo",_
    wstyle,_
    100, 100,_             ' initial x, y position
    500,500,_              ' initual size
    NULL, _               ' parent window handle
    NULL, _               ' window menu handle
    hInstance, _           ' program instance handle
    BYVAL NULL)           ' creation parameters

    if hWnd = 0 THEN MessageBox 0,"Unable to create window","Error",0: exit function


    ' create

    'pre-emptive message if there is a failure
    dim fr AS LONG
    fr=FREEFILE:OPEN "OpenglAbility.txt" FOR OUTPUT AS fr:PRINT #fr,"Unable to use Opengl":CLOSE fr

    dim as long i,j
    dim as string stts=string$(1000," ")
    fr=FREEFILE:OPEN "settings.txt" FOR BINARY AS fr:GET$ #fr,1,stts:CLOSE fr
    stts=UCASE$(stts)+chr$(10): i=INSTR(stts,"MULTISAMPLING ")
    if i>0 THEN
        j=INSTR(i,stts,CHR$(10))
        if j>0 THEN
            i=INSTR(i+13,stts," ON"): if i>0 THEN if i<j THEN antialias=1
        end if
    end if

    hDC   = GetDC(hWnd)
    'setup pixel format


    dim pfd AS PIXELFORMATDESCRIPTOR

    pfd.nSize           = SIZEOF(PIXELFORMATDESCRIPTOR) 'Size of UDT structure
    pfd.nVersion        = 1                             'Version. Always set to 1.
    pfd.dwFlags         = PFD_DRAW_TO_WINDOW OR _      'Support Window
                          PFD_SUPPORT_OPENGL OR _      'Support OpenGL
                          PFD_DOUBLEBUFFER             'Support Double Buffering
    pfd.iPixelType      = PFD_TYPE_RGBA                'Red, Green, Blue, & Alpha Mode
    pfd.cColorBits      = 32                            '32-Bit Color Mode
    pfd.cRedBits        = NULL                         'Ignore Color and Shift Bits...
    pfd.cRedShift       = NULL                         '...
    pfd.cGreenBits      = NULL                         '...
    pfd.cGreenShift     = NULL                         '...
    pfd.cBlueBits       = NULL                         '...
    pfd.cBlueShift      = NULL                         '...
    pfd.cAlphaBits      = NULL                         'No Alpha Buffer
    pfd.cAlphaShift     = NULL                         'Ignore Shift Bit.
    pfd.cAccumBits      = NULL                         'No Accumulation Buffer
    pfd.cAccumRedBits   = NULL                         'Ignore Accumulation Bits...
    pfd.cAccumGreenBits = NULL                         '...
    pfd.cAccumBlueBits  = NULL                         '...
    pfd.cAccumAlphaBits = NULL                         '... Good Cereal! ;)
    pfd.cDepthBits      = 16                            ' bits z-buffer depth 8 16 24
    pfd.cStencilBits    = 1                             'Stencil Buffer
    pfd.cAuxBuffers     = NULL                         'No Auxiliary Buffer
    pfd.iLayerType      = PFD_MAIN_PLANE               'Main Drawing Plane
    pfd.bReserved       = NULL                         'Reserved
    pfd.dwLayerMask     = NULL                         'Ignore Layer Masks...
    pfd.dwVisibleMask   = NULL                         '...
    pfd.dwDamageMask    = NULL                         '...

    nPixelFormat = ChoosePixelFormat(hDC, @pfd) ' First without multisampling
    SetPixelFormat(hDC, nPixelFormat, @pfd)
    hRC = wglCreateContext (hDC)
    wglMakeCurrent hDC, hRC
    opengl_extensions hDC
    'messagebox 0,"anti-alias "+str$(antialias),"note",0
    if (antiAlias<>0)AND(ArbMultisampleSupported<>0) THEN ReqNewMode=1
    if ReqNewMode<>0 THEN

        ' completely destroy this window
        wglMakeCurrent hDC, NULL
        wglDeleteContext hRC
        ReleaseDC hWnd,hDC
        ReqShutDown=-1:DestroyWindow(hWnd):ReqShutDown=0

        ' then recreate new window with multisampling ability
        wstyle= WS_VISIBLE OR WS_OVERLAPPEDWINDOW
        hWnd = _
        CreateWindowEx(NULL, ClassName, "OpenGL Split View Demo", wstyle,100, 100,500,500,NULL,NULL, hInstance, BYVAL NULL)
        if hWnd = 0 THEN MessageBox 0,"Unable to create window","Error",0: exit function
        hDC   = GetDC(hWnd)
        SetPixelFormat(hDC,ArbMultiSampleFormat , @pfd)
        hRC = wglCreateContext(hDC)
        wglMakeCurrent hDC, hRC
    end if

    ReqNewMode=0 ' done

    initialise_OpenGL(hWnd,hDC,hRC)

    timerval=16 ' a bit less than 1/60 sec
    SetTimer hWnd,1,timerval,NULL

    iCmdShow=SW_NORMAL
    ShowWindow hWnd, iCmdShow
    UpdateWindow hWnd

    ShowWindow( hWnd, iCmdShow )
    UpdateWindow( hWnd )
     
    while( GetMessage( @wMsg, NULL, 0, 0 ) <> FALSE )    
        TranslateMessage( @wMsg )
        DispatchMessage( @wMsg )
    wend
term:    
    function = wMsg.wParam

end function

end WinMain( GetModuleHandle( null ), null, Command( ), SW_NORMAL )
