

''========================================================================
'' T*=
'' The program uses a "split window" view, rendering four views of the
'' same scene in one window (e.g. uesful for 3D modelling software). This
'' demo uses scissors to separete the four different rendering areas from
'' each other.
''
'' (If the code seems a little bit strange here and there, it may be
''  because I am not a friend of orthogonal projections)
''========================================================================


' PB 8.04 translation from FreeBasic 0.18.3 distr GL examples
' Charles E V Pegge 29 Feb 2008

''========================================================================

    #DIM ALL
    #COMPILE EXE

    #INCLUDE "WIN32API.INC"
    #INCLUDE "OPENGL32.INC"

    MACRO NULL=0
    MACRO FALSE=0
    MACRO TRUE=-1
    MACRO PI=3.14159265358979323846



' ARB Extensions

'Sep 2006
MACRO WGL_NUMBER_PIXEL_FORMATS_ARB      =&h2000
MACRO WGL_DRAW_TO_WINDOW_ARB            =&h2001
MACRO WGL_DRAW_TO_BITMAP_ARB            =&h2002
MACRO WGL_ACCELERATION_ARB              =&h2003
MACRO WGL_NEED_PALETTE_ARB              =&h2004
MACRO WGL_NEED_SYSTEM_PALETTE_ARB       =&h2005
MACRO WGL_SWAP_LAYER_BUFFERS_ARB        =&h2006
MACRO WGL_SWAP_METHOD_ARB               =&h2007
MACRO WGL_NUMBER_OVERLAYS_ARB           =&h2008
MACRO WGL_NUMBER_UNDERLAYS_ARB          =&h2009
MACRO WGL_TRANSPARENT_ARB               =&h200A
MACRO WGL_TRANSPARENT_RED_VALUE_ARB     =&h2037
MACRO WGL_TRANSPARENT_GREEN_VALUE_ARB   =&h2038
MACRO WGL_TRANSPARENT_BLUE_VALUE_ARB    =&h2039
MACRO WGL_TRANSPARENT_ALPHA_VALUE_ARB   =&h203A
MACRO WGL_TRANSPARENT_INDEX_VALUE_ARB   =&h203B
MACRO WGL_SHARE_DEPTH_ARB               =&h200C
MACRO WGL_SHARE_STENCIL_ARB             =&h200D
MACRO WGL_SHARE_ACCUM_ARB               =&h200E
MACRO WGL_SUPPORT_GDI_ARB               =&h200F
MACRO WGL_SUPPORT_OPENGL_ARB            =&h2010
MACRO WGL_DOUBLE_BUFFER_ARB             =&h2011
MACRO WGL_STEREO_ARB                    =&h2012
MACRO WGL_PIXEL_TYPE_ARB                =&h2013
MACRO WGL_COLOR_BITS_ARB                =&h2014
MACRO WGL_RED_BITS_ARB                  =&h2015
MACRO WGL_RED_SHIFT_ARB                 =&h2016
MACRO WGL_GREEN_BITS_ARB                =&h2017
MACRO WGL_GREEN_SHIFT_ARB               =&h2018
MACRO WGL_BLUE_BITS_ARB                 =&h2019
MACRO WGL_BLUE_SHIFT_ARB                =&h201A
MACRO WGL_ALPHA_BITS_ARB                =&h201B
MACRO WGL_ALPHA_SHIFT_ARB               =&h201C
MACRO WGL_ACCUM_BITS_ARB                =&h201D
MACRO WGL_ACCUM_RED_BITS_ARB            =&h201E
MACRO WGL_ACCUM_GREEN_BITS_ARB          =&h201F
MACRO WGL_ACCUM_BLUE_BITS_ARB           =&h2020
MACRO WGL_ACCUM_ALPHA_BITS_ARB          =&h2021
MACRO WGL_DEPTH_BITS_ARB                =&h2022
MACRO WGL_STENCIL_BITS_ARB              =&h2023
MACRO WGL_AUX_BUFFERS_ARB               =&h2024
MACRO WGL_NO_ACCELERATION_ARB           =&h2025
MACRO WGL_GENERIC_ACCELERATION_ARB      =&h2026
MACRO WGL_FULL_ACCELERATION_ARB         =&h2027
MACRO WGL_SWAP_EXCHANGE_ARB             =&h2028
MACRO WGL_SWAP_COPY_ARB                 =&h2029
MACRO WGL_SWAP_UNDEFINED_ARB            =&h202A
MACRO WGL_TYPE_RGBA_ARB                 =&h202B
MACRO WGL_TYPE_COLORINDEX_ARB           =&h202C

MACRO WGL_SAMPLE_BUFFERS_ARB            =&h2041
MACRO WGL_SAMPLES_ARB                   =&h2042

MACRO GL_MULTISAMPLE_ARB                =&h809D
MACRO GL_SAMPLE_ALPHA_TO_COVERAGE_ARB   =&h809E
MACRO GL_SAMPLE_ALPHA_TO_ONE_ARB        =&h809F
MACRO GL_SAMPLE_COVERAGE_ARB            =&h80A0
MACRO GL_SAMPLE_BUFFERS_ARB             =&h80A8
MACRO GL_SAMPLES_ARB                    =&h80A9
MACRO GL_SAMPLE_COVERAGE_VALUE_ARB      =&h80AA
MACRO GL_SAMPLE_COVERAGE_INVERT_ARB     =&h80AB


' ARB extension needed for for shadow mapping

MACRO GL_DEPTH_TEXTURE_MODE_ARB         =&h884B

MACRO GL_TEXTURE_COMPARE_MODE_ARB       =&h884C
MACRO GL_TEXTURE_COMPARE_FUNC_ARB       =&h884D
MACRO GL_COMPARE_R_TO_TEXTURE_ARB       =&h884E

' Opengl 1.4
MACRO GL_COMPARE_R_TO_TEXTURE           =&h884E




''========================================================================
'' Global variables
''========================================================================

    GLOBAL grtic1,grtic2,freq AS QUAD
    GLOBAL fps,grlap AS SINGLE
    GLOBAL refresh,bselect,kselect,keyd,char,ReqShutDown AS LONG
    GLOBAL bLeft,bMid,bRight,bWheel AS LONG
    GLOBAL sposx,sposy,mposx,mposy,eposx,eposy AS LONG
    GLOBAL wWidth,wHeight AS LONG
    GLOBAL hDC,hRC AS LONG
    GLOBAL shadows,shadowable AS LONG
    GLOBAL antialias, multisampling, wglChoosePixelFormatARB AS LONG
    GLOBAL nPixelFormat,ReqNewMode,arbMultisampleFormat, arbMultisampleSupported AS LONG
    GLOBAL timerval AS LONG

''========================================================================
    GLOBAL doredraw AS LONG
    '' Mouse position
    GLOBAL xpos, ypos AS LONG
    '' Window size wWidth wHeight
    '' Active view: 0 = none, 1 = upper left, 2 = upper right, 3 = lower left,
    '' 4 = lower right
    GLOBAL active_view AS LONG
    '' Rotation around each axis
    GLOBAL rot_x, rot_y, rot_z AS LONG

''========================================================================




''========================================================================
'' DrawTorus() - Draw a solid torus (use a display list for the model)
''========================================================================

MACRO TORUS_MAJOR   =  1.5
MACRO TORUS_MINOR   =  0.5
MACRO TORUS_MAJOR_RES = 32
MACRO TORUS_MINOR_RES = 32

SUB DrawTorus( )
    STATIC torus_list AS DWORD
    LOCAL i, j, k AS LONG
    LOCAL s, t, x, y, z, nx, ny, nz, gscale, twopi AS DOUBLE
    IF( torus_list = 0 ) THEN
        '' Start recording displaylist
        torus_list = glGenLists( 1 )
        glNewList( torus_list, %GL_COMPILE_AND_EXECUTE )

        '' Draw torus
        twopi = 2.0 * PI
        FOR i = 0 TO TORUS_MINOR_RES-1
            glBegin( %GL_QUAD_STRIP )
            FOR j = 0 TO TORUS_MAJOR_RES
                FOR k = 1 TO 0 STEP -1
                    s = (i + k) MOD TORUS_MINOR_RES + 0.5
                    t = j MOD TORUS_MAJOR_RES

                    '' Calculate point on surface
                    x = (TORUS_MAJOR+TORUS_MINOR*COS(s*twopi/TORUS_MINOR_RES))*COS(t*twopi/TORUS_MAJOR_RES)
                    y = TORUS_MINOR * SIN(s * twopi / TORUS_MINOR_RES)
                    z = (TORUS_MAJOR+TORUS_MINOR*COS(s*twopi/TORUS_MINOR_RES))*SIN(t*twopi/TORUS_MAJOR_RES)

                    '' Calculate surface normal
                    nx = x - TORUS_MAJOR*COS(t*twopi/TORUS_MAJOR_RES)
                    ny = y
                    nz = z - TORUS_MAJOR*SIN(t*twopi/TORUS_MAJOR_RES)
                    gscale = 1.0 / SQR( nx*nx + ny*ny + nz*nz )
                    nx = nx*gscale
                    ny = ny*gscale
                    nz = nz*gscale

                    glNormal3f( nx, ny, nz )
                    glVertex3f( x, y, z )
                NEXT
            NEXT
            glEnd()
        NEXT

        '' Stop recording displaylist
        glEndList()
    ELSE
        '' Playback displaylist
        glCallList( torus_list )
    END IF
END SUB


''========================================================================
'' DrawScene() - Draw the scene (a rotating torus)
''========================================================================

SUB DrawScene(  )
    DIM model_diffuse(0 TO 3)AS STATIC SINGLE: ARRAY ASSIGN model_diffuse() =  1.0, 0.8, 0.8, 1.0
    DIM model_specular(0 TO 3) AS STATIC SINGLE: ARRAY ASSIGN model_specular() =  0.6, 0.6, 0.6, 1.0
    DIM model_shininess AS STATIC SINGLE: model_shininess = 20.0

    glPushMatrix( )

    '' Rotate the object
    glRotatef( rot_x*0.5, 1.0, 0.0, 0.0 )
    glRotatef( rot_y*0.5, 0.0, 1.0, 0.0 )
    glRotatef( rot_z*0.5, 0.0, 0.0, 1.0 )

    '' Set model color (used for orthogonal views, lighting disabled)
    glColor4fv( model_diffuse(0) )

    '' Set model material (used for perspective view, lighting enabled)
    glMaterialfv( %GL_FRONT, %GL_DIFFUSE, model_diffuse(0) )
    glMaterialfv( %GL_FRONT, %GL_SPECULAR, model_specular(0) )
    glMaterialf(  %GL_FRONT, %GL_SHININESS, model_shininess )

    '' Draw torus
    DrawTorus()

    glPopMatrix()
END SUB


''========================================================================
'' DrawGrid() - Draw a 2D grid (used for orthogonal views)
''========================================================================

SUB DrawGrid( BYVAL gscale AS SINGLE, BYVAL gsteps AS INTEGER )
    LOCAL i AS LONG
    LOCAL x, y AS SINGLE

    glPushMatrix( )

    '' Set background to some dark bluish grey
    glClearColor( 0.05, 0.05, 0.2, 0.0)
    glClear( %GL_COLOR_BUFFER_BIT )

    '' Setup modelview matrix (flat XY view)
    glLoadIdentity( )
    gluLookAt( 0.0, 0.0, 1.0, _
               0.0, 0.0, 0.0, _
               0.0, 1.0, 0.0 )

    '' We don't want to update the Z-buffer
    glDepthMask( %GL_FALSE )

    '' Set grid color
    glDisable %GL_LIGHTING
    glColor3f( 0.0, 0.5, 0.5 )

    glBegin( %GL_LINES )

    '' Horizontal lines
    x = gscale * 0.5 * (gsteps-1)
    y = -gscale * 0.5 * (gsteps-1)
    FOR i = 0 TO gsteps-1
        glVertex3f( -x, y, 0.0 )
        glVertex3f( x, y, 0.0 )
        y = y + gscale
    NEXT

    '' Vertical lines
    x = -gscale * 0.5 * (gsteps-1)
    y = gscale * 0.5 * (gsteps-1)
    FOR i = 0 TO gsteps-1
        glVertex3f( x, -y, 0.0 )
        glVertex3f( x, y, 0.0 )
        x = x + gscale
    NEXT

    glEnd()

    '' Enable Z-buffer writing again
    glDepthMask( %GL_TRUE )

    glPopMatrix()
END SUB


''========================================================================
'' DrawAllViews()
''========================================================================

SUB DrawAllViews( )
    DIM light_position(0 TO 3) AS STATIC SINGLE: ARRAY ASSIGN light_position() = 0.0, 8.0, 8.0, 1.0
    DIM light_diffuse(0 TO 3) AS STATIC SINGLE: ARRAY ASSIGN light_diffuse() = 1.0, 1.0, 1.0, 1.0
    DIM light_specular(0 TO 3) AS STATIC SINGLE: ARRAY ASSIGN light_specular() =  1.0, 1.0, 1.0, 1.0
    DIM light_ambient(0 TO 3) AS STATIC SINGLE: ARRAY ASSIGN light_ambient() =  0.2, 0.2, 0.3, 1.0
    LOCAL aspect  AS DOUBLE

    '' Calculate aspect of window
    IF( wheight > 0 ) THEN
        aspect = wwidth / wheight
    ELSE
        aspect = 1.0
    END IF

    '' Clear screen
    glClearColor( 0.0, 0.0, 0.0, 0.0 )
    glClear( %GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT )

    '' Enable scissor test
    glEnable( %GL_SCISSOR_TEST )

    '' Enable depth test
    glEnable( %GL_DEPTH_TEST )
    glDepthFunc( %GL_LEQUAL )


    '' ** ORTHOGONAL VIEWS **

    '' For orthogonal views, use wireframe rendering
    glPolygonMode( %GL_FRONT_AND_BACK, %GL_LINE )

    '' Enable line anti-aliasing
    glEnable( %GL_LINE_SMOOTH )
    glEnable( %GL_BLEND )
    glBlendFunc( %GL_SRC_ALPHA, %GL_ONE_MINUS_SRC_ALPHA )

    '' Setup orthogonal projection matrix
    glMatrixMode( %GL_PROJECTION )
    glLoadIdentity( )
    glOrtho( -3.0*aspect, 3.0*aspect, -3.0, 3.0, 1.0, 50.0 )

    '' Upper left view (TOP VIEW)
    glViewport( 0, wheight\2, wwidth\2, wheight\2 )
    glScissor( 0, wheight\2, wwidth\2, wheight\2 )
    glMatrixMode( %GL_MODELVIEW )
    glLoadIdentity()
    gluLookAt( 0.0, 10.0, 1e-3, _  '' Eye-position (above)
               0.0, 0.0, 0.0,   _  '' View-point
               0.0, 1.0, 0.0 )     '' Up-vector
    DrawGrid( 0.5, 12 )
    DrawScene( )

    '' Lower left view (FRONT VIEW)
    glViewport( 0, 0, wwidth\2, wheight\2 )
    glScissor( 0, 0, wwidth\2, wheight\2 )
    glMatrixMode( %GL_MODELVIEW )
    glLoadIdentity( )
    gluLookAt( 0.0, 0.0, 10.0, _   '' Eye-position (in front of)
               0.0, 0.0, 0.0,  _   '' View-point
               0.0, 1.0, 0.0 )     '' Up-vector
    DrawGrid( 0.5, 12 )
    DrawScene()

    '' Lower right view (SIDE VIEW)
    glViewport( wwidth\2, 0, wwidth\2, wheight\2 )
    glScissor( wwidth\2, 0, wwidth\2, wheight\2 )
    glMatrixMode( %GL_MODELVIEW )
    glLoadIdentity()
    gluLookAt( 10.0, 0.0, 0.0, _   '' Eye-position (to the right)
               0.0, 0.0, 0.0,  _   '' View-point
               0.0, 1.0, 0.0 )     '' Up-vector
    DrawGrid( 0.5, 12 )
    DrawScene( )

    '' Disable line anti-aliasing
    glDisable( %GL_LINE_SMOOTH )
    glDisable( %GL_BLEND )


    '' ** PERSPECTIVE VIEW **

    '' For perspective view, use solid rendering
    glPolygonMode( %GL_FRONT_AND_BACK, %GL_FILL )

    '' Enable face culling (faster rendering)
    glEnable( %GL_CULL_FACE )
    glCullFace( %GL_BACK )
    glFrontFace( %GL_CW )

    '' Setup perspective projection matrix
    glMatrixMode( %GL_PROJECTION )
    glLoadIdentity( )
    gluPerspective( 65.0, aspect, 1.0, 50.0 )

    '' Upper right view (PERSPECTIVE VIEW)
    glViewport( wwidth\2, wheight\2, wwidth\2, wheight\2 )
    glScissor( wwidth\2, wheight\2, wwidth\2, wheight\2 )
    glMatrixMode( %GL_MODELVIEW )
    glLoadIdentity()
    gluLookAt( 3.0, 1.5, 3.0, _    '' Eye-position
               0.0, 0.0, 0.0, _    '' View-point
               0.0, 1.0, 0.0 )     '' Up-vector

    '' Configure and enable light source 1
    glLightfv( %GL_LIGHT1, %GL_POSITION, light_position(0) )
    glLightfv( %GL_LIGHT1, %GL_AMBIENT, light_ambient(0) )
    glLightfv( %GL_LIGHT1, %GL_DIFFUSE, light_diffuse(0) )
    glLightfv( %GL_LIGHT1, %GL_SPECULAR, light_specular(0) )
    glEnable( %GL_LIGHT1 )
    glEnable( %GL_LIGHTING )

    '' Draw scene
    DrawScene( )

    '' Disable lighting
    glDisable( %GL_LIGHTING )

    '' Disable face culling
    glDisable( %GL_CULL_FACE )

    '' Disable depth test
    glDisable( %GL_DEPTH_TEST )

    '' Disable scissor test
    glDisable( %GL_SCISSOR_TEST )


    '' Draw a border around the active view
    IF( active_view > 0 AND active_view <> 2 ) THEN
        glViewport( 0, 0, wwidth, wheight )
        glMatrixMode( %GL_PROJECTION )
        glLoadIdentity()
        glOrtho( 0.0, 2.0, 0.0, 2.0, 0.0, 1.0 )
        glMatrixMode( %GL_MODELVIEW )
        glLoadIdentity()
        glColor3f( 1.0, 1.0, 0.6 )
        glTranslatef( (active_view-1) AND 1, 1-(active_view-1)\2, 0.0 )
        glBegin( %GL_LINE_STRIP )
          glVertex2i( 0, 0 )
          glVertex2i( 1, 0 )
          glVertex2i( 1, 1 )
          glVertex2i( 0, 1 )
          glVertex2i( 0, 0 )
        glEnd()
    END IF
END SUB




SUB do_the_next_frame(BYVAL hWnd AS LONG )  ' construct each frame
                                              '
    STATIC firstframe AS LONG
    STATIC shro AS LONG, shrt AS SINGLE, shre AS SINGLE

    LOCAL signal AS LONG: signal=0

    ' timing
    QueryPerformanceCounter grtic2
    grlap=(grtic2-grtic1)*1000000/freq '
    fps=0.99*fps+10000/grlap ' moving average frames per sec

    ' screen refresh
    IF bselect+kselect+refresh=0 THEN grtic1=grtic2: GOTO xdo_frame ' no need to update frame
    refresh=0

    glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

    '=============
    DrawAllViews()
    '=============
    glFinish   ' wait until all operations complete
    SwapBuffers HDC

    'IF firstframe=0 THEN SetWindowPos hWnd,%HWND_TOP,100,100,500,500,0: firstframe=1
    grtic1=grtic2
xdo_frame:

    EXIT SUB
                                              '
END SUB                                    '





FUNCTION WndProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD,BYVAL wParam AS LONG, BYVAL lParam AS LONG)AS LONG

    DIM gmf(255) AS GLOBAL GLYPHMETRICSFLOAT
    DIM keys(255) AS GLOBAL LONG
    DIM viewport(3) AS GLOBAL LONG
    DIM mapref(15) AS GLOBAL LONG
    DIM cameraProjectionMatrix(15) AS SINGLE
    DIM modelview(15) AS GLOBAL DOUBLE
    DIM projection(15) AS GLOBAL DOUBLE

    LOCAL i,j AS LONG
    LOCAL x,y,z AS LONG

    IF wmsg=%wm_paint THEN refresh=1

    SELECT CASE wMsg

    CASE %WM_ACTIVATE
        IF HIWRD(wParam) THEN EXIT FUNCTION
     CASE %WM_DESTROY
        GOTO terminate
     CASE %WM_TIMER
         IF wParam=1 THEN
             do_the_next_frame (hWnd)
            IF ReqShutDown THEN terminate
        END IF
        EXIT FUNCTION
    CASE %WM_KEYDOWN
        wParam=wParam AND 255
        keys(wParam) = 1: keyd=wParam: kselect=wParam
        IF wParam=%VK_ESCAPE THEN ReqShutdown=1: EXIT FUNCTION
        IF (wParam>=%VK_F1)AND(wParam<=%VK_F12) THEN
            '..
        END IF
        EXIT FUNCTION
    CASE %WM_KEYUP
        wParam=wParam AND 255
        keys(wParam) = 0:keyd=0
        EXIT FUNCTION
    CASE %WM_CHAR: char=wParam
        EXIT FUNCTION
    CASE %WM_MOUSEMOVE
        bselect=bselect OR 1
        mPosX = LOWRD(lParam)
        mPosY = HIWRD(lParam)
        IF bleft=1 THEN
            x=mPosX: y=mPosY
            '' Depending on which view was selected, rotate around different axes
            SELECT CASE active_view
            CASE 1
                rot_x = rot_x + y - ypos
                rot_z = rot_z + x - xpos
            CASE 3
                rot_x = rot_x + y - ypos
                rot_y = rot_y + x - xpos
            CASE 4
                rot_y = rot_y + x - xpos
                rot_z = rot_z + y - ypos
            CASE ELSE
                '' Do nothing for perspective view, or if no view is selected
            END SELECT
            '' Remember mouse position
            xpos = x
            ypos = y
       END IF
        EXIT FUNCTION
    CASE %WM_LBUTTONUP
        bLeft = 0:ePosX=mPosX:ePosY=mPosy
        '' Deselect any previously selected view
        active_view = 0
        EXIT FUNCTION
    CASE %WM_MBUTTONUP
        bMid = 0:ePosX=mPosX:ePosY=mPosy
        EXIT FUNCTION
    CASE %WM_RBUTTONUP
        bRight = 0:ePosX=mPosX:ePosY=mPosy
        EXIT FUNCTION
    CASE %WM_LBUTTONDOWN
        bLeft  = 1:sPosX=mPosX:sPosY=mPosy
        bSelect = bselect OR 2
        xpos = LOWRD(lParam)
        ypos = HIWRD(lParam)
        '' Detect which of the four views was clicked
        active_view = 1
        IF( xpos >= wwidth\2 ) THEN
            INCR active_view
        END IF
        IF( ypos >= wheight\2 ) THEN
            active_view = active_view + 2
        END IF
        doredraw = TRUE
        EXIT FUNCTION
    CASE %WM_MBUTTONDOWN
        bMid  = 1:sPosX=mPosX:sPosY=mPosy
        bSelect = bselect OR 2
        EXIT FUNCTION
    CASE %WM_RBUTTONDOWN
        bRight = 1:sPosX=mPosX:sPosY=mPosY
        bSelect = bselect OR 2
        EXIT FUNCTION
    CASE %WM_MOUSEWHEEL
        bWheel = HIWRD(wParam)
        bselect=1
        EXIT FUNCTION
    CASE %WM_SIZE
        'Set the viewport to new dimensions
        wWidth=CLNG(LOWRD(lParam))
        wHeight=CLNG(HIWRD(lParam))
        glViewport 0, 0, wWidth, wHeight
        viewport(0)=0:viewport(1)=0:viewport(2)=wWidth:viewport(3)=wHeight
        glMatrixMode %GL_PROJECTION
        glLoadIdentity
        gluPerspective(45.0, wWidth/wHeight, 1.0, 100.0)
        glMatrixMode %GL_MODELVIEW
        glGetDoublev %GL_MODELVIEW_MATRIX, modelview(0)
        glGetDoublev %GL_PROJECTION_MATRIX, projection(0)
        refresh=1
        EXIT FUNCTION

    CASE ELSE
        FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)

    END SELECT
    EXIT FUNCTION

terminate:
    IF ReqShutDown<0 THEN EXIT FUNCTION ' dont terminate
    KillTimer hWnd,1
    CLOSE
    glDeleteLists 1000, 255 ' font
    wglMakeCurrent hDC, %NULL
    wglDeleteContext hRC
    ReleaseDC hWnd,hDC
    PostQuitMessage 0


END FUNCTION


DECLARE FUNCTION args1 ( BYVAL p AS LONG) AS LONG
DECLARE FUNCTION wglChooseP(BYVAL hDC AS LONG, iAttributes AS LONG, fAttributes AS SINGLE, BYVAL n AS LONG, pixelFormat AS LONG, numFormats AS LONG) AS LONG

SUB change_screen_settings (sWidth AS LONG,sHeight AS LONG )
    LOCAL dmScreenSettings AS DEVMODE
    dmScreenSettings.dmSize = SIZEOF(dmScreenSettings)
    dmScreenSettings.dmPelsWidth = sWidth
    dmScreenSettings.dmPelsHeight = sHeight
    dmScreenSettings.dmFields = %DM_PELSWIDTH OR %DM_PELSHEIGHT
    ChangeDisplaySettings dmScreenSettings,%CDS_FULLSCREEN
END SUB


SUB opengl_extensions(hDC AS LONG)
    ERRCLEAR
    LOCAL az AS STRING
    LOCAL f  AS LONG:f=FREEFILE
    LOCAL p  AS ASCIIZ PTR
    LOCAL pa AS LONG PTR
    OPEN "ability\opengl.txt" FOR OUTPUT AS f
    PRINT#f,"OPENGL on this PC:": PRINT#f,TIME$+"  "+DATE$:PRINT#f,""

    p=glGetString(%GL_VENDOR): PRINT #f,    "Vendor:     " & @p
    p=glGetString(%GL_RENDERER): PRINT #f,  "Renderer:   " & @p
    p=glGetString(%GL_VERSION): PRINT #f,   "Version:    " & @p
    PRINT #f,""

    'InitMultitexture()
    'DIM params(15) AS LOCAL GLint
    'glGetIntegerv(GL_MAX_TEXTURE_UNITS_ARB, params(0))
    'MaxTexelUnits=params(0)
    'glMultiTexCoord2fARB = wglGetProcAddress("glMultiTexCoord2fARB")
    'glActiveTextureARB   = wglGetProcAddress("glActiveTextureARB")
    'PRINT#f,glMultiTexCoord2fARB,glActiveTextureARB, MaxTexelUnits
    p=glGetString( %GL_EXTENSIONS)
    ' Check for necessary extensions
    IF LEN(@p)=0 THEN
        PRINT#f, "There are no Opengl Extensions availanle"
    ELSEIF (INSTR(@p, "GL_ARB_depth_texture ")=0 ) OR ( INSTR (@p, "GL_ARB_shadow ")=0) THEN
        PRINT#f, "I require ARB_depth_texture and ARB_shadow extensions so I cant do shadow mapping"
        shadows=0
    ELSE
        PRINT#f,"With ARB_depth_texture and ARB_shadow extensions I can do shadows"
        shadowAble=1
    END IF
    IF LEN(@p) THEN
        PRINT#f,"":  PRINT#f,"EXTENSIONS SUPPORTED:": PRINT#f,""
        REPLACE " " WITH $CRLF IN @p
        PRINT #f, @p
        pa=wglGetProcAddress("wglGetExtensionsStringARB")
        IF pa THEN
            CALL DWORD pa USING args1 (wglGetCurrentDC()) TO p
            'WGL_ARB_multisample
            IF (INSTR(@p, "WGL_ARB_multisample ") )  THEN
                PRINT#f,"":PRINT#f,"I support ARBmultiSampling"
                multisampling=1
                wglChoosePixelFormatARB=wglGetProcAddress("wglChoosePixelFormatARB")
                DIM iA(31) AS GLOBAL LONG
                ia(00)=WGL_DRAW_TO_WINDOW_ARB: ia(01)=%GL_TRUE
                ia(02)=WGL_SUPPORT_OPENGL_ARB: ia(03)=%GL_TRUE
                ia(04)=WGL_ACCELERATION_ARB:   ia(05)=WGL_FULL_ACCELERATION_ARB
                ia(06)=WGL_COLOR_BITS_ARB:     ia(07)=24
                ia(08)=WGL_ALPHA_BITS_ARB:     ia(09)=8
                ia(10)=WGL_DEPTH_BITS_ARB:     ia(11)=16
                ia(12)=WGL_STENCIL_BITS_ARB:   ia(13)=1
                ia(14)=WGL_DOUBLE_BUFFER_ARB:  ia(15)=%GL_TRUE
                ia(16)=WGL_SAMPLE_BUFFERS_ARB: ia(17)=%GL_TRUE
                ia(18)=WGL_SAMPLES_ARB:        ia(19)=4
                ia(20)=0:                      ia(21)=0
                '// First We Check To See If We Can Get A Pixel Format For 4 Samples
                '// Get Our Current Device Context
                LOCAL valid AS LONG
                LOCAL numFormats AS LONG
                DIM fAttributes(1) AS SINGLE
                LOCAL pixelformat AS LONG
                ' hDC            Specifies the window associated with the device context.
                ' piAttribIList  Specifies the list of integer attributes in {type, value} pairs. The list is terminated with a type value of 0.
                ' pfAttribFList  Specifies the list of floating-point attributes in {type, value} pairs. The list is terminated with a type value of 0.0.
                ' nMaxFormats    Specifies the maximum number of pixel formats to be returned.
                ' piFormats      Points to an array of returned indices of the matching pixel formats. The closest matching formats are at the top of the list. The caller must allocated the array with at least nMaxFormats entries.
                ' nNumFormats    Returns the number of matching formats. This value may be larger than nMaxFormats
                CALL DWORD wglChoosePixelFormatARB USING wglChooseP(hDC,iA(0),fAttributes(0),1,pixelFormat,numFormats) TO valid
                IF pixelformat THEN
                    PRINT#f,"Pixel format for multisampling supported "+STR$(pixelformat)
                    arbMultisampleFormat=pixelFormat
                    arbMultisampleSupported=1
                ELSE
                    PRINT#f,"A Pixel format for multisampling could not be found"
                END IF
            END IF
            az=@p
            REPLACE " " WITH $CRLF IN az
            PRINT#f,"":  PRINT#f,"WGL EXTENSIONS SUPPORTED:": PRINT#f,""
            PRINT #f, az
        END IF
    END IF
term:
    CLOSE (f)
END SUB




SUB initialise_OpenGL (hWnd AS LONG, hDC AS LONG, hRC AS LONG)


'    'BuildFont
'    DIM glFont AS LOGFONT, glFontHandle AS LONG
'    glFont.lfHeight         = -0.1                           'Height Of Font
'    glFont.lfWeight         = %FW_BOLD                       'Font Weight
'    glFont.lfCharSet        = %ANSI_CHARSET                  'Character Set Identifier
'    glFont.lfOutPrecision   = %OUT_TT_PRECIS                 'Output Precision
'    glFont.lfClipPrecision  = %CLIP_DEFAULT_PRECIS           'Clipping Precision
'    glFont.lfQuality        = %ANTIALIASED_QUALITY           'Output Quality
'    glFont.lfPitchAndFamily = %FF_DONTCARE OR %DEFAULT_PITCH 'Family And Pitch
'    glFont.lfFaceName       = "Arial" '"Comic Sans MS"       'Font Name
'    glFontHandle = CreateFontIndirect(glFont)
'    glFontHandle = SelectObject(hDC, glFontHandle)
'    '
'    wglUseFontOutlines hDC, 0, 255, 1000, 0.0, 0.2, %WGL_FONT_POLYGONS, VARPTR(gmf(0))
'    '
'    DeleteObject SelectObject(hDC, glFontHandle)

END SUB






FUNCTION WINMAIN ALIAS "WinMain" ( _
    BYVAL hInstance     AS DWORD, _
    BYVAL hPrevInstance AS DWORD, _
    BYVAL lpCmdLine     AS ASCIIZ PTR, _
    BYVAL iCmdShow      AS LONG) _
    EXPORT AS LONG

    QueryPerformanceFrequency freq


    LOCAL msg       AS tagMsg
    LOCAL wce       AS WndClassEx
    LOCAL ClassName AS ASCIIZ * 80
    LOCAL hWnd      AS DWORD


    ClassName         = "Split View"
    wce.cbSize        = SIZEOF(wce)
    wce.style         = %CS_HREDRAW OR %CS_VREDRAW
    wce.lpfnWndProc   = CODEPTR(WndProc)
    wce.cbClsExtra    = 0
    wce.cbWndExtra    = 0
    wce.hInstance     = hInstance
    wce.hIcon         = LoadIcon(hInstance, "PBGL_EXAMPLE")
    wce.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
    wce.hbrBackground = %NULL
    wce.lpszMenuName  = %NULL
    wce.lpszClassName = VARPTR(ClassName)
    wce.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)

    IF ISFALSE(RegisterClassEx(wce)) THEN
        MSGBOX "Unable to Register Window Class."
        EXIT FUNCTION
    END IF



    LOCAL wstyle AS DWORD
    wstyle=%WS_SIZEBOX OR %WS_CAPTION
    'wstyle=%WS_POPUP or  %WS_SIZEBOX
    'wstyle=%WS_VISIBLE OR %WS_SIZEBOX ' OR %WS_POPUP '
    'wstyle= %WS_VISIBLE OR %WS_OVERLAPPEDWINDOW
    hWnd = CreateWindowEx(%NULL,_
    ClassName,_
    "OpenGL Split View Demo",_
    wstyle,_
    100, 100,_             ' initial x, y position
    500,500,_              ' initual size
    %NULL, _               ' parent window handle
    %NULL, _               ' window menu handle
    hInstance, _           ' program instance handle
    BYVAL %NULL)           ' creation parameters

    IF hWnd = 0 THEN MSGBOX "Unable to create window": EXIT FUNCTION


    ' create

    'pre-emptive message if there is a failure
    LOCAL fr AS LONG
    fr=FREEFILE:OPEN "ability\opengl.txt" FOR OUTPUT AS fr:PRINT#fr,"Unable to use Opengl":CLOSE fr

    LOCAL i,j AS LONG
    LOCAL stts AS STRING
    fr=FREEFILE:OPEN "ability\settings.txt" FOR BINARY AS fr:GET$ #fr,8000,stts:CLOSE fr
    stts=UCASE$(stts)+CHR$(10): i=INSTR(stts,"MULTISAMPLING ")
    IF i>0 THEN
        j=INSTR(i,stts,CHR$(10))
        IF j>0 THEN
            i=INSTR(i+13,stts," ON"): IF i>0 THEN IF i<j THEN antialias=1
        END IF
    END IF

    hDC   = GetDC(hWnd)
    'setup pixel format


    GLOBAL pfd AS PIXELFORMATDESCRIPTOR

    pfd.nSize           = SIZEOF(PIXELFORMATDESCRIPTOR) 'Size of UDT structure
    pfd.nVersion        = 1                             'Version. Always set to 1.
    pfd.dwFlags         = %PFD_DRAW_TO_WINDOW OR _      'Support Window
                          %PFD_SUPPORT_OPENGL OR _      'Support OpenGL
                          %PFD_DOUBLEBUFFER             'Support Double Buffering
    pfd.iPixelType      = %PFD_TYPE_RGBA                'Red, Green, Blue, & Alpha Mode
    pfd.cColorBits      = 32                            '32-Bit Color Mode
    pfd.cRedBits        = %NULL                         'Ignore Color and Shift Bits...
    pfd.cRedShift       = %NULL                         '...
    pfd.cGreenBits      = %NULL                         '...
    pfd.cGreenShift     = %NULL                         '...
    pfd.cBlueBits       = %NULL                         '...
    pfd.cBlueShift      = %NULL                         '...
    pfd.cAlphaBits      = %NULL                         'No Alpha Buffer
    pfd.cAlphaShift     = %NULL                         'Ignore Shift Bit.
    pfd.cAccumBits      = %NULL                         'No Accumulation Buffer
    pfd.cAccumRedBits   = %NULL                         'Ignore Accumulation Bits...
    pfd.cAccumGreenBits = %NULL                         '...
    pfd.cAccumBlueBits  = %NULL                         '...
    pfd.cAccumAlphaBits = %NULL                         '... Good Cereal! ;)
    pfd.cDepthBits      = 16                            ' bits z-buffer depth 8 16 24
    pfd.cStencilBits    = 1                             'Stencil Buffer
    pfd.cAuxBuffers     = %NULL                         'No Auxiliary Buffer
    pfd.iLayerType      = %PFD_MAIN_PLANE               'Main Drawing Plane
    pfd.bReserved       = %NULL                         'Reserved
    pfd.dwLayerMask     = %NULL                         'Ignore Layer Masks...
    pfd.dwVisibleMask   = %NULL                         '...
    pfd.dwDamageMask    = %NULL                         '...

    nPixelFormat = ChoosePixelFormat(hDC, pfd) ' First without multisampling
    SetPixelFormat(hDC, nPixelFormat, pfd)
    hRC = wglCreateContext (hDC)
    wglMakeCurrent hDC, hRC
    opengl_extensions hDC

    IF (antiAlias<>0)AND(ArbMultisampleSupported<>0) THEN ReqNewMode=1
    IF ReqNewMode<>0 THEN

        ' completely destroy this window
        wglMakeCurrent hDC, %NULL
        wglDeleteContext hRC
        ReleaseDC hWnd,hDC
        ReqShutDown=-1:DestroyWindow(hWnd):ReqShutDown=0

        ' then recreate new window with multisampling ability
        wstyle= %WS_VISIBLE OR %WS_OVERLAPPEDWINDOW
        hWnd = _
        CreateWindowEx(%NULL, ClassName, "OpenGL Split View Demo", wstyle,100, 100,500,500,%NULL,%NULL, hInstance, BYVAL %NULL)
        IF hWnd = 0 THEN MSGBOX "Unable to create window": EXIT FUNCTION
        hDC   = GetDC(hWnd)
        SetPixelFormat(hDC,ArbMultiSampleFormat , pfd)
        hRC = wglCreateContext(hDC)
        wglMakeCurrent hDC, hRC
    END IF

    ReqNewMode=0 ' done

    initialise_OpenGL(hWnd,hDC,hRC)

    timerval=16 ' a bit less than 1/60 sec
    SetTimer hWnd,1,timerval,%NULL

    iCmdShow=%SW_NORMAL
    ShowWindow hWnd, iCmdShow
    UpdateWindow hWnd

    DO WHILE GetMessage(Msg, %NULL, 0, 0)
        TranslateMessage Msg
        DispatchMessage Msg
        IF ReqNewMode<>0 THEN EXIT LOOP
    LOOP

term:
    FUNCTION = msg.wParam
END FUNCTION
